/* ***********************************************************
 * This file was automatically generated on 2020-01-31.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;
import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.thing.CommonTriggerEvents;
import org.eclipse.smarthome.core.library.types.StringType;
import org.eclipse.smarthome.core.library.types.PointType;
import org.eclipse.smarthome.core.library.types.DateTimeType;
import org.eclipse.smarthome.core.library.types.DecimalType;
import org.eclipse.smarthome.core.library.types.OnOffType;
import java.time.ZoneId;

/**
 * Determine position, velocity and altitude using GPS
 */
public class BrickletGPS extends Device {
	public final static int DEVICE_IDENTIFIER = 222;
	public final static String DEVICE_DISPLAY_NAME = "GPS Bricklet";

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(DEVICE_DISPLAY_NAME, "brickletgps", DEVICE_IDENTIFIER, BrickletGPS.class, BrickletGPSActions.class, "2.0.0");

	public final static byte FUNCTION_GET_COORDINATES = (byte)1;
	public final static byte FUNCTION_GET_STATUS = (byte)2;
	public final static byte FUNCTION_GET_ALTITUDE = (byte)3;
	public final static byte FUNCTION_GET_MOTION = (byte)4;
	public final static byte FUNCTION_GET_DATE_TIME = (byte)5;
	public final static byte FUNCTION_RESTART = (byte)6;
	public final static byte FUNCTION_SET_COORDINATES_CALLBACK_PERIOD = (byte)7;
	public final static byte FUNCTION_GET_COORDINATES_CALLBACK_PERIOD = (byte)8;
	public final static byte FUNCTION_SET_STATUS_CALLBACK_PERIOD = (byte)9;
	public final static byte FUNCTION_GET_STATUS_CALLBACK_PERIOD = (byte)10;
	public final static byte FUNCTION_SET_ALTITUDE_CALLBACK_PERIOD = (byte)11;
	public final static byte FUNCTION_GET_ALTITUDE_CALLBACK_PERIOD = (byte)12;
	public final static byte FUNCTION_SET_MOTION_CALLBACK_PERIOD = (byte)13;
	public final static byte FUNCTION_GET_MOTION_CALLBACK_PERIOD = (byte)14;
	public final static byte FUNCTION_SET_DATE_TIME_CALLBACK_PERIOD = (byte)15;
	public final static byte FUNCTION_GET_DATE_TIME_CALLBACK_PERIOD = (byte)16;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_COORDINATES = 17;
	private final static int CALLBACK_STATUS = 18;
	private final static int CALLBACK_ALTITUDE = 19;
	private final static int CALLBACK_MOTION = 20;
	private final static int CALLBACK_DATE_TIME = 21;

	public final static int FIX_NO_FIX = 1;
	public final static int FIX_2D_FIX = 2;
	public final static int FIX_3D_FIX = 3;
	public final static int RESTART_TYPE_HOT_START = 0;
	public final static int RESTART_TYPE_WARM_START = 1;
	public final static int RESTART_TYPE_COLD_START = 2;
	public final static int RESTART_TYPE_FACTORY_RESET = 3;

	private List<CoordinatesListener> listenerCoordinates = new CopyOnWriteArrayList<CoordinatesListener>();
	private List<StatusListener> listenerStatus = new CopyOnWriteArrayList<StatusListener>();
	private List<AltitudeListener> listenerAltitude = new CopyOnWriteArrayList<AltitudeListener>();
	private List<MotionListener> listenerMotion = new CopyOnWriteArrayList<MotionListener>();
	private List<DateTimeListener> listenerDateTime = new CopyOnWriteArrayList<DateTimeListener>();

	public class Coordinates {
		public long latitude;
		public char ns;
		public long longitude;
		public char ew;
		public int pdop;
		public int hdop;
		public int vdop;
		public int epe;

		public String toString() {
			return "[" + "latitude = " + latitude + ", " + "ns = " + ns + ", " + "longitude = " + longitude + ", " + "ew = " + ew + ", " + "pdop = " + pdop + ", " + "hdop = " + hdop + ", " + "vdop = " + vdop + ", " + "epe = " + epe + "]";
		}
	}

	public class Status {
		public int fix;
		public int satellitesView;
		public int satellitesUsed;

		public String toString() {
			return "[" + "fix = " + fix + ", " + "satellitesView = " + satellitesView + ", " + "satellitesUsed = " + satellitesUsed + "]";
		}
	}

	public class Altitude {
		public int altitude;
		public int geoidalSeparation;

		public String toString() {
			return "[" + "altitude = " + altitude + ", " + "geoidalSeparation = " + geoidalSeparation + "]";
		}
	}

	public class Motion {
		public long course;
		public long speed;

		public String toString() {
			return "[" + "course = " + course + ", " + "speed = " + speed + "]";
		}
	}

	public class DateTime {
		public long date;
		public long time;

		public String toString() {
			return "[" + "date = " + date + ", " + "time = " + time + "]";
		}
	}

	/**
	 * This listener is triggered periodically with the period that is set by
	 * {@link BrickletGPS#setCoordinatesCallbackPeriod(long)}. The parameters are the same
	 * as for {@link BrickletGPS#getCoordinates()}.
	 * 
	 * The {@link BrickletGPS.CoordinatesListener} listener is only triggered if the coordinates changed
	 * since the last triggering and if there is currently a fix as indicated by
	 * {@link BrickletGPS#getStatus()}.
	 */
	public interface CoordinatesListener extends DeviceListener {
		public void coordinates(long latitude, char ns, long longitude, char ew, int pdop, int hdop, int vdop, int epe);
	}

	/**
	 * This listener is triggered periodically with the period that is set by
	 * {@link BrickletGPS#setStatusCallbackPeriod(long)}. The parameters are the same
	 * as for {@link BrickletGPS#getStatus()}.
	 * 
	 * The {@link BrickletGPS.StatusListener} listener is only triggered if the status changed since the
	 * last triggering.
	 */
	public interface StatusListener extends DeviceListener {
		public void status(int fix, int satellitesView, int satellitesUsed);
	}

	/**
	 * This listener is triggered periodically with the period that is set by
	 * {@link BrickletGPS#setAltitudeCallbackPeriod(long)}. The parameters are the same
	 * as for {@link BrickletGPS#getAltitude()}.
	 * 
	 * The {@link BrickletGPS.AltitudeListener} listener is only triggered if the altitude changed since
	 * the last triggering and if there is currently a fix as indicated by
	 * {@link BrickletGPS#getStatus()}.
	 */
	public interface AltitudeListener extends DeviceListener {
		public void altitude(int altitude, int geoidalSeparation);
	}

	/**
	 * This listener is triggered periodically with the period that is set by
	 * {@link BrickletGPS#setMotionCallbackPeriod(long)}. The parameters are the same
	 * as for {@link BrickletGPS#getMotion()}.
	 * 
	 * The {@link BrickletGPS.MotionListener} listener is only triggered if the motion changed since the
	 * last triggering and if there is currently a fix as indicated by
	 * {@link BrickletGPS#getStatus()}.
	 */
	public interface MotionListener extends DeviceListener {
		public void motion(long course, long speed);
	}

	/**
	 * This listener is triggered periodically with the period that is set by
	 * {@link BrickletGPS#setDateTimeCallbackPeriod(long)}. The parameters are the same
	 * as for {@link BrickletGPS#getDateTime()}.
	 * 
	 * The {@link BrickletGPS.DateTimeListener} listener is only triggered if the date or time changed
	 * since the last triggering.
	 */
	public interface DateTimeListener extends DeviceListener {
		public void dateTime(long date, long time);
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletGPS(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 1;

		deviceIdentifier = DEVICE_IDENTIFIER;
		deviceDisplayName = DEVICE_DISPLAY_NAME;

		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_COORDINATES)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_STATUS)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_ALTITUDE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_MOTION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_DATE_TIME)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_RESTART)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_COORDINATES_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_COORDINATES_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_STATUS_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_STATUS_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_ALTITUDE_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_ALTITUDE_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_MOTION_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_MOTION_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_DATE_TIME_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_DATE_TIME_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_COORDINATES] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				long latitude = IPConnection.unsignedInt(bb.getInt());
				char ns = (char)(bb.get());
				long longitude = IPConnection.unsignedInt(bb.getInt());
				char ew = (char)(bb.get());
				int pdop = IPConnection.unsignedShort(bb.getShort());
				int hdop = IPConnection.unsignedShort(bb.getShort());
				int vdop = IPConnection.unsignedShort(bb.getShort());
				int epe = IPConnection.unsignedShort(bb.getShort());

				for (CoordinatesListener listener: listenerCoordinates) {
					listener.coordinates(latitude, ns, longitude, ew, pdop, hdop, vdop, epe);
				}
			}
		};

		callbacks[CALLBACK_STATUS] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int fix = IPConnection.unsignedByte(bb.get());
				int satellitesView = IPConnection.unsignedByte(bb.get());
				int satellitesUsed = IPConnection.unsignedByte(bb.get());

				for (StatusListener listener: listenerStatus) {
					listener.status(fix, satellitesView, satellitesUsed);
				}
			}
		};

		callbacks[CALLBACK_ALTITUDE] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int altitude = (bb.getInt());
				int geoidalSeparation = (bb.getInt());

				for (AltitudeListener listener: listenerAltitude) {
					listener.altitude(altitude, geoidalSeparation);
				}
			}
		};

		callbacks[CALLBACK_MOTION] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				long course = IPConnection.unsignedInt(bb.getInt());
				long speed = IPConnection.unsignedInt(bb.getInt());

				for (MotionListener listener: listenerMotion) {
					listener.motion(course, speed);
				}
			}
		};

		callbacks[CALLBACK_DATE_TIME] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				long date = IPConnection.unsignedInt(bb.getInt());
				long time = IPConnection.unsignedInt(bb.getInt());

				for (DateTimeListener listener: listenerDateTime) {
					listener.dateTime(date, time);
				}
			}
		};

		ipcon.addDevice(this);
	}

	/**
	 * Returns the GPS coordinates. Latitude and longitude are given in the
	 * ``DD.dddddd°`` format, the value 57123468 means 57.123468°.
	 * The parameter ``ns`` and ``ew`` are the cardinal directions for
	 * latitude and longitude. Possible values for ``ns`` and ``ew`` are 'N', 'S', 'E'
	 * and 'W' (north, south, east and west).
	 * 
	 * PDOP, HDOP and VDOP are the dilution of precision (DOP) values. They specify
	 * the additional multiplicative effect of GPS satellite geometry on GPS
	 * precision. See
	 * `here &lt;https://en.wikipedia.org/wiki/Dilution_of_precision_(GPS)&gt;`__
	 * for more information.
	 * 
	 * EPE is the "Estimated Position Error". This is not the
	 * absolute maximum error, it is the error with a specific confidence. See
	 * `here &lt;https://www.nps.gov/gis/gps/WhatisEPE.html&gt;`__ for more information.
	 * 
	 * This data is only valid if there is currently a fix as indicated by
	 * {@link BrickletGPS#getStatus()}.
	 */
	public Coordinates getCoordinates() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_COORDINATES, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Coordinates obj = new Coordinates();
		obj.latitude = IPConnection.unsignedInt(bb.getInt());
		obj.ns = (char)(bb.get());
		obj.longitude = IPConnection.unsignedInt(bb.getInt());
		obj.ew = (char)(bb.get());
		obj.pdop = IPConnection.unsignedShort(bb.getShort());
		obj.hdop = IPConnection.unsignedShort(bb.getShort());
		obj.vdop = IPConnection.unsignedShort(bb.getShort());
		obj.epe = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Returns the current fix status, the number of satellites that are in view and
	 * the number of satellites that are currently used.
	 * 
	 * Possible fix status values can be:
	 * 
	 * \verbatim
	 *  "Value", "Description"
	 * 
	 *  "1", "No Fix, {@link BrickletGPS#getCoordinates()}, {@link BrickletGPS#getAltitude()} and {@link BrickletGPS#getMotion()} return invalid data"
	 *  "2", "2D Fix, only {@link BrickletGPS#getCoordinates()} and {@link BrickletGPS#getMotion()} return valid data"
	 *  "3", "3D Fix, {@link BrickletGPS#getCoordinates()}, {@link BrickletGPS#getAltitude()} and {@link BrickletGPS#getMotion()} return valid data"
	 * \endverbatim
	 * 
	 * There is also a :ref:`blue LED &lt;gps_bricklet_fix_led&gt;` on the Bricklet that
	 * indicates the fix status.
	 */
	public Status getStatus() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_STATUS, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Status obj = new Status();
		obj.fix = IPConnection.unsignedByte(bb.get());
		obj.satellitesView = IPConnection.unsignedByte(bb.get());
		obj.satellitesUsed = IPConnection.unsignedByte(bb.get());

		return obj;
	}

	/**
	 * Returns the current altitude and corresponding geoidal separation.
	 * 
	 * This data is only valid if there is currently a fix as indicated by
	 * {@link BrickletGPS#getStatus()}.
	 */
	public Altitude getAltitude() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_ALTITUDE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Altitude obj = new Altitude();
		obj.altitude = (bb.getInt());
		obj.geoidalSeparation = (bb.getInt());

		return obj;
	}

	/**
	 * Returns the current course and speed. A course of 0° means the Bricklet is
	 * traveling north bound and 90° means it is traveling east bound.
	 * 
	 * Please note that this only returns useful values if an actual movement
	 * is present.
	 * 
	 * This data is only valid if there is currently a fix as indicated by
	 * {@link BrickletGPS#getStatus()}.
	 */
	public Motion getMotion() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_MOTION, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Motion obj = new Motion();
		obj.course = IPConnection.unsignedInt(bb.getInt());
		obj.speed = IPConnection.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Returns the current date and time. The date is
	 * given in the format ``ddmmyy`` and the time is given
	 * in the format ``hhmmss.sss``. For example, 140713 means
	 * 14.07.13 as date and 195923568 means 19:59:23.568 as time.
	 */
	public DateTime getDateTime() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_DATE_TIME, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		DateTime obj = new DateTime();
		obj.date = IPConnection.unsignedInt(bb.getInt());
		obj.time = IPConnection.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Restarts the GPS Bricklet, the following restart types are available:
	 * 
	 * \verbatim
	 *  "Value", "Description"
	 * 
	 *  "0", "Hot start (use all available data in the NV store)"
	 *  "1", "Warm start (don't use ephemeris at restart)"
	 *  "2", "Cold start (don't use time, position, almanacs and ephemeris at restart)"
	 *  "3", "Factory reset (clear all system/user configurations at restart)"
	 * \endverbatim
	 */
	public void restart(int restartType) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_RESTART, this);

		bb.put((byte)restartType);

		sendRequest(bb.array());
	}

	/**
	 * Sets the period with which the {@link BrickletGPS.CoordinatesListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 * 
	 * The {@link BrickletGPS.CoordinatesListener} listener is only triggered if the coordinates changed
	 * since the last triggering.
	 */
	public void setCoordinatesCallbackPeriod(long period) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_COORDINATES_CALLBACK_PERIOD, this);

		bb.putInt((int)period);

		sendRequest(bb.array());
	}

	/**
	 * Returns the period as set by {@link BrickletGPS#setCoordinatesCallbackPeriod(long)}.
	 */
	public long getCoordinatesCallbackPeriod() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_COORDINATES_CALLBACK_PERIOD, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnection.unsignedInt(bb.getInt());

		return period;
	}

	/**
	 * Sets the period with which the {@link BrickletGPS.StatusListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 * 
	 * The {@link BrickletGPS.StatusListener} listener is only triggered if the status changed since the
	 * last triggering.
	 */
	public void setStatusCallbackPeriod(long period) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_STATUS_CALLBACK_PERIOD, this);

		bb.putInt((int)period);

		sendRequest(bb.array());
	}

	/**
	 * Returns the period as set by {@link BrickletGPS#setStatusCallbackPeriod(long)}.
	 */
	public long getStatusCallbackPeriod() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_STATUS_CALLBACK_PERIOD, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnection.unsignedInt(bb.getInt());

		return period;
	}

	/**
	 * Sets the period with which the {@link BrickletGPS.AltitudeListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 * 
	 * The {@link BrickletGPS.AltitudeListener} listener is only triggered if the altitude changed since
	 * the last triggering.
	 */
	public void setAltitudeCallbackPeriod(long period) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_ALTITUDE_CALLBACK_PERIOD, this);

		bb.putInt((int)period);

		sendRequest(bb.array());
	}

	/**
	 * Returns the period as set by {@link BrickletGPS#setAltitudeCallbackPeriod(long)}.
	 */
	public long getAltitudeCallbackPeriod() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_ALTITUDE_CALLBACK_PERIOD, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnection.unsignedInt(bb.getInt());

		return period;
	}

	/**
	 * Sets the period with which the {@link BrickletGPS.MotionListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 * 
	 * The {@link BrickletGPS.MotionListener} listener is only triggered if the motion changed since the
	 * last triggering.
	 */
	public void setMotionCallbackPeriod(long period) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_MOTION_CALLBACK_PERIOD, this);

		bb.putInt((int)period);

		sendRequest(bb.array());
	}

	/**
	 * Returns the period as set by {@link BrickletGPS#setMotionCallbackPeriod(long)}.
	 */
	public long getMotionCallbackPeriod() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_MOTION_CALLBACK_PERIOD, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnection.unsignedInt(bb.getInt());

		return period;
	}

	/**
	 * Sets the period with which the {@link BrickletGPS.DateTimeListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 * 
	 * The {@link BrickletGPS.DateTimeListener} listener is only triggered if the date or time changed
	 * since the last triggering.
	 */
	public void setDateTimeCallbackPeriod(long period) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_DATE_TIME_CALLBACK_PERIOD, this);

		bb.putInt((int)period);

		sendRequest(bb.array());
	}

	/**
	 * Returns the period as set by {@link BrickletGPS#setDateTimeCallbackPeriod(long)}.
	 */
	public long getDateTimeCallbackPeriod() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_DATE_TIME_CALLBACK_PERIOD, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnection.unsignedInt(bb.getInt());

		return period;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
	 * The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
	 * connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always as
	 * position 'z'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnection.string(bb, 8);
		obj.connectedUid = IPConnection.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Adds a Coordinates listener.
	 */
	public void addCoordinatesListener(CoordinatesListener listener) {
		listenerCoordinates.add(listener);
	}

	/**
	 * Removes a Coordinates listener.
	 */
	public void removeCoordinatesListener(CoordinatesListener listener) {
		listenerCoordinates.remove(listener);
	}

	/**
	 * Adds a Status listener.
	 */
	public void addStatusListener(StatusListener listener) {
		listenerStatus.add(listener);
	}

	/**
	 * Removes a Status listener.
	 */
	public void removeStatusListener(StatusListener listener) {
		listenerStatus.remove(listener);
	}

	/**
	 * Adds a Altitude listener.
	 */
	public void addAltitudeListener(AltitudeListener listener) {
		listenerAltitude.add(listener);
	}

	/**
	 * Removes a Altitude listener.
	 */
	public void removeAltitudeListener(AltitudeListener listener) {
		listenerAltitude.remove(listener);
	}

	/**
	 * Adds a Motion listener.
	 */
	public void addMotionListener(MotionListener listener) {
		listenerMotion.add(listener);
	}

	/**
	 * Removes a Motion listener.
	 */
	public void removeMotionListener(MotionListener listener) {
		listenerMotion.remove(listener);
	}

	/**
	 * Adds a DateTime listener.
	 */
	public void addDateTimeListener(DateTimeListener listener) {
		listenerDateTime.add(listener);
	}

	/**
	 * Removes a DateTime listener.
	 */
	public void removeDateTimeListener(DateTimeListener listener) {
		listenerDateTime.remove(listener);
	}

    private final Logger logger = LoggerFactory.getLogger(BrickletGPS.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletGPS.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletGPSConfig cfg = (BrickletGPSConfig) config.as(BrickletGPSConfig.class);
        this.addCoordinatesListener((latitude, ns, longitude, ew, pdop, hdop, vdop, epe) -> {if(true) {updateStateFn.accept("BrickletGPSLocation", transformBrickletGPSLocationCallback0(latitude, ns, longitude, ew, pdop, hdop, vdop, epe, cfg));}});
		this.addStatusListener((fix, satellitesView, satellitesUsed) -> {if(true) {updateStateFn.accept("BrickletGPSFix", transformBrickletGPSFixCallback0(fix, satellitesView, satellitesUsed, cfg));}});
		this.addStatusListener((fix, satellitesView, satellitesUsed) -> {if(true) {updateStateFn.accept("BrickletGPSSatellitesInView", transformBrickletGPSSatellitesInViewCallback0(fix, satellitesView, satellitesUsed, cfg));}});
		this.addStatusListener((fix, satellitesView, satellitesUsed) -> {if(true) {updateStateFn.accept("BrickletGPSSatellitesUsed", transformBrickletGPSSatellitesUsedCallback0(fix, satellitesView, satellitesUsed, cfg));}});
		this.addAltitudeListener((altitude, geoidalSeparation) -> {if(true) {updateStateFn.accept("BrickletGPSAltitude", transformBrickletGPSAltitudeCallback0(altitude, geoidalSeparation, cfg));}});
		this.addAltitudeListener((altitude, geoidalSeparation) -> {if(true) {updateStateFn.accept("BrickletGPSGeoidalSeparation", transformBrickletGPSGeoidalSeparationCallback0(altitude, geoidalSeparation, cfg));}});
		this.addMotionListener((course, speed) -> {if(true) {updateStateFn.accept("BrickletGPSCourse", transformBrickletGPSCourseCallback0(course, speed, cfg));}});
		this.addMotionListener((course, speed) -> {if(true) {updateStateFn.accept("BrickletGPSSpeed", transformBrickletGPSSpeedCallback0(course, speed, cfg));}});
		this.addDateTimeListener((date, time) -> {if(true) {updateStateFn.accept("BrickletGPSDateTime", transformBrickletGPSDateTimeCallback0(date, time, cfg));}});
        this.setStatusCallbackPeriod(cfg.statusUpdateInterval);
		        this.setAltitudeCallbackPeriod(cfg.altitudeUpdateInterval);
		        this.setMotionCallbackPeriod(cfg.motionUpdateInterval);
		{
		BrickletGPSCoordinatesConfig channelCfg = getChannelConfigFn.apply("BrickletGPSLocation").as(BrickletGPSCoordinatesConfig.class);
		this.setCoordinatesCallbackPeriod(channelCfg.updateInterval);
		}
		{
		BrickletGPSFixConfig channelCfg = getChannelConfigFn.apply("BrickletGPSFix").as(BrickletGPSFixConfig.class);
		
		}
		{
		BrickletGPSSatellitesInViewConfig channelCfg = getChannelConfigFn.apply("BrickletGPSSatellitesInView").as(BrickletGPSSatellitesInViewConfig.class);
		
		}
		{
		BrickletGPSSatellitesUsedConfig channelCfg = getChannelConfigFn.apply("BrickletGPSSatellitesUsed").as(BrickletGPSSatellitesUsedConfig.class);
		
		}
		{
		BrickletGPSAltitudeConfig channelCfg = getChannelConfigFn.apply("BrickletGPSAltitude").as(BrickletGPSAltitudeConfig.class);
		
		}
		{
		BrickletGPSGeoidalSeparationConfig channelCfg = getChannelConfigFn.apply("BrickletGPSGeoidalSeparation").as(BrickletGPSGeoidalSeparationConfig.class);
		
		}
		{
		BrickletGPSCourseConfig channelCfg = getChannelConfigFn.apply("BrickletGPSCourse").as(BrickletGPSCourseConfig.class);
		
		}
		{
		BrickletGPSSpeedConfig channelCfg = getChannelConfigFn.apply("BrickletGPSSpeed").as(BrickletGPSSpeedConfig.class);
		
		}
		{
		BrickletGPSDateTimeConfig channelCfg = getChannelConfigFn.apply("BrickletGPSDateTime").as(BrickletGPSDateTimeConfig.class);
		this.setDateTimeCallbackPeriod(channelCfg.updateInterval);
		}
		{
		BrickletGPSRestartConfig channelCfg = getChannelConfigFn.apply("BrickletGPSRestart").as(BrickletGPSRestartConfig.class);
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        BrickletGPSConfig cfg = (BrickletGPSConfig) config.as(BrickletGPSConfig.class);
        this.listenerCoordinates.clear();
		this.listenerStatus.clear();
		this.listenerStatus.clear();
		this.listenerStatus.clear();
		this.listenerAltitude.clear();
		this.listenerAltitude.clear();
		this.listenerMotion.clear();
		this.listenerMotion.clear();
		this.listenerDateTime.clear();
        this.setCoordinatesCallbackPeriod(0);
		
		
		
		
		
		
		
		this.setDateTimeCallbackPeriod(0);
		this.setStatusCallbackPeriod(0);
		        this.setAltitudeCallbackPeriod(0);
		        this.setMotionCallbackPeriod(0);
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletGPSConfig cfg = (BrickletGPSConfig) config.as(BrickletGPSConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletGPSLocation");
		result.add("BrickletGPSFix");
		result.add("BrickletGPSSatellitesInView");
		result.add("BrickletGPSSatellitesUsed");
		result.add("BrickletGPSAltitude");
		result.add("BrickletGPSGeoidalSeparation");
		result.add("BrickletGPSCourse");
		result.add("BrickletGPSSpeed");
		result.add("BrickletGPSDateTime");
		result.add("BrickletGPSRestart");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletGPSCoordinates":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletGPSCoordinates"), "Location", "Location").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletGPSCoordinates")).withDescription("The location as determined by the bricklet.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(true).build().toStateDescription()).build();
            case "BrickletGPSFix":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletGPSFix"), "Fix", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletGPSFix")).withDescription("If enabled, a fix is currently available")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(true).build().toStateDescription()).build();
            case "BrickletGPSSatellitesInView":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletGPSSatellitesInView"), "Satellites In View", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletGPSSatellitesInView")).withDescription("The number of satellites that are in view.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%d %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletGPSSatellitesUsed":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletGPSSatellitesUsed"), "Satellites Used", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletGPSSatellitesUsed")).withDescription("The number of satellites that are currently used.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%d %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletGPSAltitude":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletGPSAltitude"), "Altitude", "Number:Length").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletGPSAltitude")).withDescription("The current altitude")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%.2f %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletGPSGeoidalSeparation":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletGPSGeoidalSeparation"), "Geoidal Separation", "Number:Length").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletGPSGeoidalSeparation")).withDescription("The geoidal separation corresponding to the current altitude")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%.2f %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletGPSCourse":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletGPSCourse"), "Course", "Number:Angle").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletGPSCourse")).withDescription("The current course. A course of 0° means the Bricklet is traveling north bound and 90° means it is traveling east bound. Please note that this only returns useful values if an actual movement is present.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%.2f %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletGPSSpeed":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletGPSSpeed"), "Speed", "Number:Speed").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletGPSSpeed")).withDescription("The current speed. Please note that this only returns useful values if an actual movement is present.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%.2f").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletGPSDateTime":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletGPSDateTime"), "Date Time", "DateTime").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletGPSDateTime")).withDescription("The current date and time.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(true).build().toStateDescription()).build();
            case "BrickletGPSRestart":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletGPSRestart"), "Restart", "String").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletGPSRestart")).withDescription("Restarts the GPS Bricklet, the following restart types are available:<ul><li>Hot start (use all available data in the NV store)</li> <li>Warm start (don't use ephemeris at restart)</li> <li>Cold start (don't use time, position, almanacs and ephemeris at restart)</li> <li>Factory reset (clear all system/user configurations at restart)</li></ul>")
.withCommandDescription(CommandDescriptionBuilder.create().withCommandOption(new CommandOption("0", "Hot Start")).withCommandOption(new CommandOption("1", "Warm Start")).withCommandOption(new CommandOption("2", "Cold Start")).withCommandOption(new CommandOption("3", "Factory reset")).build()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge GPS Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Determine position, velocity and altitude using GPS").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletGPSLocation", new ChannelTypeUID("tinkerforge", "BrickletGPSCoordinates")).withLabel("Location").build(), new ChannelDefinitionBuilder("BrickletGPSFix", new ChannelTypeUID("tinkerforge", "BrickletGPSFix")).withLabel("Fix").build(), new ChannelDefinitionBuilder("BrickletGPSSatellitesInView", new ChannelTypeUID("tinkerforge", "BrickletGPSSatellitesInView")).withLabel("Satellites In View").build(), new ChannelDefinitionBuilder("BrickletGPSSatellitesUsed", new ChannelTypeUID("tinkerforge", "BrickletGPSSatellitesUsed")).withLabel("Satellites Used").build(), new ChannelDefinitionBuilder("BrickletGPSAltitude", new ChannelTypeUID("tinkerforge", "BrickletGPSAltitude")).withLabel("Altitude").build(), new ChannelDefinitionBuilder("BrickletGPSGeoidalSeparation", new ChannelTypeUID("tinkerforge", "BrickletGPSGeoidalSeparation")).withLabel("Geoidal Separation").build(), new ChannelDefinitionBuilder("BrickletGPSCourse", new ChannelTypeUID("tinkerforge", "BrickletGPSCourse")).withLabel("Course").build(), new ChannelDefinitionBuilder("BrickletGPSSpeed", new ChannelTypeUID("tinkerforge", "BrickletGPSSpeed")).withLabel("Speed").build(), new ChannelDefinitionBuilder("BrickletGPSDateTime", new ChannelTypeUID("tinkerforge", "BrickletGPSDateTime")).withLabel("Date Time").build(), new ChannelDefinitionBuilder("BrickletGPSRestart", new ChannelTypeUID("tinkerforge", "BrickletGPSRestart")).withLabel("Restart").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletgps":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("statusUpdateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval for the status in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Status Update Interval").withUnit("ms").build(), ConfigDescriptionParameterBuilder.create("altitudeUpdateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval for the altitude and geodial separation in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Altitude Update Interval").withUnit("ms").build(), ConfigDescriptionParameterBuilder.create("motionUpdateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval for the course and speed in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Motion Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletGPSCoordinates":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletGPSFix":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletGPSSatellitesInView":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletGPSSatellitesUsed":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletGPSAltitude":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletGPSGeoidalSeparation":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletGPSCourse":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletGPSSpeed":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletGPSDateTime":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletGPSRestart":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletGPSConfig cfg = (BrickletGPSConfig) config.as(BrickletGPSConfig.class);
        switch(channel) {
            case "BrickletGPSLocation":
               return;
            case "BrickletGPSFix": {
                   BrickletGPSFixConfig channelCfg = channelConfig.as(BrickletGPSFixConfig.class);
                   {
            Status value = this.getStatus();
            if(true)
                updateStateFn.accept(channel, transformBrickletGPSFixGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletGPSSatellitesInView": {
                   BrickletGPSSatellitesInViewConfig channelCfg = channelConfig.as(BrickletGPSSatellitesInViewConfig.class);
                   {
            Status value = this.getStatus();
            if(true)
                updateStateFn.accept(channel, transformBrickletGPSSatellitesInViewGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletGPSSatellitesUsed": {
                   BrickletGPSSatellitesUsedConfig channelCfg = channelConfig.as(BrickletGPSSatellitesUsedConfig.class);
                   {
            Status value = this.getStatus();
            if(true)
                updateStateFn.accept(channel, transformBrickletGPSSatellitesUsedGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletGPSAltitude": {
                   BrickletGPSAltitudeConfig channelCfg = channelConfig.as(BrickletGPSAltitudeConfig.class);
                   {
            Altitude value = this.getAltitude();
            if(true)
                updateStateFn.accept(channel, transformBrickletGPSAltitudeGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletGPSGeoidalSeparation": {
                   BrickletGPSGeoidalSeparationConfig channelCfg = channelConfig.as(BrickletGPSGeoidalSeparationConfig.class);
                   {
            Altitude value = this.getAltitude();
            if(true)
                updateStateFn.accept(channel, transformBrickletGPSGeoidalSeparationGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletGPSCourse": {
                   BrickletGPSCourseConfig channelCfg = channelConfig.as(BrickletGPSCourseConfig.class);
                   {
            Motion value = this.getMotion();
            if(true)
                updateStateFn.accept(channel, transformBrickletGPSCourseGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletGPSSpeed": {
                   BrickletGPSSpeedConfig channelCfg = channelConfig.as(BrickletGPSSpeedConfig.class);
                   {
            Motion value = this.getMotion();
            if(true)
                updateStateFn.accept(channel, transformBrickletGPSSpeedGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletGPSDateTime": {
                   BrickletGPSDateTimeConfig channelCfg = channelConfig.as(BrickletGPSDateTimeConfig.class);
                   {
            DateTime value = this.getDateTime();
            if(true)
                updateStateFn.accept(channel, transformBrickletGPSDateTimeGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletGPSRestart":
               return;
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletGPSConfig cfg = (BrickletGPSConfig) config.as(BrickletGPSConfig.class);
        switch(channel) {
            case "BrickletGPSRestart":
                if (command instanceof StringType) {
                    BrickletGPSRestartConfig channelCfg = channelConfig.as(BrickletGPSRestartConfig.class);
                    StringType cmd = (StringType) command;
                    this.restart(Short.valueOf(cmd.toString()));
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletGPSLocationCallback0(long latitude, char ns, long longitude, char ew, int pdop, int hdop, int vdop, int epe, BrickletGPSConfig cfg) {
        return new PointType(new DecimalType(latitude / 1000000.0 * (ns == 'N' ? 1 : -1)), new DecimalType(longitude / 1000000.0 * (ew == 'E' ? 1 : -1)));
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletGPSFixCallback0(int fix, int satellitesView, int satellitesUsed, BrickletGPSConfig cfg) {
        return fix > 1 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletGPSSatellitesInViewCallback0(int fix, int satellitesView, int satellitesUsed, BrickletGPSConfig cfg) {
        return new QuantityType(satellitesView, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletGPSSatellitesUsedCallback0(int fix, int satellitesView, int satellitesUsed, BrickletGPSConfig cfg) {
        return new QuantityType(satellitesUsed, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletGPSAltitudeCallback0(int altitude, int geoidalSeparation, BrickletGPSConfig cfg) {
        return new QuantityType(altitude / 100.0, SIUnits.METRE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletGPSGeoidalSeparationCallback0(int altitude, int geoidalSeparation, BrickletGPSConfig cfg) {
        return new QuantityType(geoidalSeparation / 100.0, SIUnits.METRE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletGPSCourseCallback0(long course, long speed, BrickletGPSConfig cfg) {
        return new QuantityType(course / 100.0, SmartHomeUnits.DEGREE_ANGLE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletGPSSpeedCallback0(long course, long speed, BrickletGPSConfig cfg) {
        return new QuantityType(speed / 100.0, SIUnits.KILOMETRE_PER_HOUR);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletGPSDateTimeCallback0(long date, long time, BrickletGPSConfig cfg) {
        return new DateTimeType(Helper.parseGPSDateTime(date, time).withZoneSameInstant(ZoneId.systemDefault()));
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletGPSFixGetter0(Status value, BrickletGPSConfig cfg) {
        return value.fix > 1 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletGPSSatellitesInViewGetter0(Status value, BrickletGPSConfig cfg) {
        return new QuantityType(value.satellitesView, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletGPSSatellitesUsedGetter0(Status value, BrickletGPSConfig cfg) {
        return new QuantityType(value.satellitesUsed, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletGPSAltitudeGetter0(Altitude value, BrickletGPSConfig cfg) {
        return new QuantityType(value.altitude / 100.0, SIUnits.METRE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletGPSGeoidalSeparationGetter0(Altitude value, BrickletGPSConfig cfg) {
        return new QuantityType(value.geoidalSeparation / 100.0, SIUnits.METRE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletGPSCourseGetter0(Motion value, BrickletGPSConfig cfg) {
        return new QuantityType(value.course / 100.0, SmartHomeUnits.DEGREE_ANGLE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletGPSSpeedGetter0(Motion value, BrickletGPSConfig cfg) {
        return new QuantityType(value.speed / 100.0, SIUnits.KILOMETRE_PER_HOUR);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletGPSDateTimeGetter0(DateTime value, BrickletGPSConfig cfg) {
        return new DateTimeType(Helper.parseGPSDateTime(value.date, value.time).withZoneSameInstant(ZoneId.systemDefault()));
    }
}
