/* ***********************************************************
 * This file was automatically generated on 2020-01-31.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;
import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.library.types.OnOffType;
import org.eclipse.smarthome.core.library.types.StringType;

/**
 * 4 galvanically isolated digital outputs
 */
public class BrickletIndustrialDigitalOut4V2 extends Device {
	public final static int DEVICE_IDENTIFIER = 2124;
	public final static String DEVICE_DISPLAY_NAME = "Industrial Digital Out 4 Bricklet 2.0";

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(DEVICE_DISPLAY_NAME, "brickletindustrialdigitalout4v2", DEVICE_IDENTIFIER, BrickletIndustrialDigitalOut4V2.class, BrickletIndustrialDigitalOut4V2Actions.class, "2.0.0");

	public final static byte FUNCTION_SET_VALUE = (byte)1;
	public final static byte FUNCTION_GET_VALUE = (byte)2;
	public final static byte FUNCTION_SET_SELECTED_VALUE = (byte)3;
	public final static byte FUNCTION_SET_MONOFLOP = (byte)4;
	public final static byte FUNCTION_GET_MONOFLOP = (byte)5;
	public final static byte FUNCTION_SET_CHANNEL_LED_CONFIG = (byte)7;
	public final static byte FUNCTION_GET_CHANNEL_LED_CONFIG = (byte)8;
	public final static byte FUNCTION_SET_PWM_CONFIGURATION = (byte)9;
	public final static byte FUNCTION_GET_PWM_CONFIGURATION = (byte)10;
	public final static byte FUNCTION_GET_SPITFP_ERROR_COUNT = (byte)234;
	public final static byte FUNCTION_SET_BOOTLOADER_MODE = (byte)235;
	public final static byte FUNCTION_GET_BOOTLOADER_MODE = (byte)236;
	public final static byte FUNCTION_SET_WRITE_FIRMWARE_POINTER = (byte)237;
	public final static byte FUNCTION_WRITE_FIRMWARE = (byte)238;
	public final static byte FUNCTION_SET_STATUS_LED_CONFIG = (byte)239;
	public final static byte FUNCTION_GET_STATUS_LED_CONFIG = (byte)240;
	public final static byte FUNCTION_GET_CHIP_TEMPERATURE = (byte)242;
	public final static byte FUNCTION_RESET = (byte)243;
	public final static byte FUNCTION_WRITE_UID = (byte)248;
	public final static byte FUNCTION_READ_UID = (byte)249;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_MONOFLOP_DONE = 6;

	public final static int CHANNEL_LED_CONFIG_OFF = 0;
	public final static int CHANNEL_LED_CONFIG_ON = 1;
	public final static int CHANNEL_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int CHANNEL_LED_CONFIG_SHOW_CHANNEL_STATUS = 3;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;

	private List<MonoflopDoneListener> listenerMonoflopDone = new CopyOnWriteArrayList<MonoflopDoneListener>();

	public class Monoflop {
		public boolean value;
		public long time;
		public long timeRemaining;

		public String toString() {
			return "[" + "value = " + value + ", " + "time = " + time + ", " + "timeRemaining = " + timeRemaining + "]";
		}
	}

	public class PWMConfiguration {
		public long frequency;
		public int dutyCycle;

		public String toString() {
			return "[" + "frequency = " + frequency + ", " + "dutyCycle = " + dutyCycle + "]";
		}
	}

	public class SPITFPErrorCount {
		public long errorCountAckChecksum;
		public long errorCountMessageChecksum;
		public long errorCountFrame;
		public long errorCountOverflow;

		public String toString() {
			return "[" + "errorCountAckChecksum = " + errorCountAckChecksum + ", " + "errorCountMessageChecksum = " + errorCountMessageChecksum + ", " + "errorCountFrame = " + errorCountFrame + ", " + "errorCountOverflow = " + errorCountOverflow + "]";
		}
	}

	/**
	 * This listener is triggered whenever a monoflop timer reaches 0. The
	 * parameters contain the channel and the current value of the channel
	 * (the value after the monoflop).
	 */
	public interface MonoflopDoneListener extends DeviceListener {
		public void monoflopDone(int channel, boolean value);
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletIndustrialDigitalOut4V2(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 0;

		deviceIdentifier = DEVICE_IDENTIFIER;
		deviceDisplayName = DEVICE_DISPLAY_NAME;

		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_VALUE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_VALUE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_SELECTED_VALUE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_MONOFLOP)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_MONOFLOP)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_CHANNEL_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CHANNEL_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_PWM_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_PWM_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_SPITFP_ERROR_COUNT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_WRITE_FIRMWARE_POINTER)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_WRITE_FIRMWARE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CHIP_TEMPERATURE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_RESET)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_WRITE_UID)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_READ_UID)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_MONOFLOP_DONE] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int channel = IPConnection.unsignedByte(bb.get());
				boolean value = (bb.get()) != 0;

				for (MonoflopDoneListener listener: listenerMonoflopDone) {
					listener.monoflopDone(channel, value);
				}
			}
		};

		ipcon.addDevice(this);
	}

	/**
	 * Sets the output value of all four channels. A value of *true* or *false* outputs
	 * logic 1 or logic 0 respectively on the corresponding channel.
	 * 
	 * Use {@link BrickletIndustrialDigitalOut4V2#setSelectedValue(int, boolean)} to change only one output channel state.
	 * 
	 * All running monoflop timers and PWMs will be aborted if this function is called.
	 * 
	 * For example: (True, True, False, False) will turn the channels 0-1 high and the
	 * channels 2-3 low.
	 */
	public void setValue(boolean[] value) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_VALUE, this);


		byte[] valueBits = new byte[1];
		Arrays.fill(valueBits, (byte)0);

		for (int i = 0; i < 4; i++) {
			if (value[i]) {
				valueBits[i / 8] |= 1 << (i % 8);
			}
		}
		for (int i = 0; i < 1; i++) {
			bb.put(valueBits[i]);
		}

		sendRequest(bb.array());
	}

	/**
	 * Returns the logic levels that are currently output on the channels.
	 */
	public boolean[] getValue() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_VALUE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		byte[] valueBits = new byte[1];
		bb.get(valueBits);
		boolean[] value = new boolean[4];
		for (int i = 0; i < 4; i++) {
			value[i] = (valueBits[i / 8] & (1 << (i % 8))) != 0;
		}


		return value;
	}

	/**
	 * Sets the output value of a specific channel without affecting the other channels.
	 * 
	 * A running monoflop timer or PWM for the specified channel will be aborted if this
	 * function is called.
	 */
	public void setSelectedValue(int channel, boolean value) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_SELECTED_VALUE, this);

		bb.put((byte)channel);
		bb.put((byte)(value ? 1 : 0));

		sendRequest(bb.array());
	}

	/**
	 * The first parameter is the desired state of the channel (*true* means output *high*
	 * and *false* means output *low*). The second parameter indicates the time that
	 * the channel should hold the state.
	 * 
	 * If this function is called with the parameters (true, 1500):
	 * The channel will turn on and in 1.5s it will turn off again.
	 * 
	 * A PWM for the selected channel will be aborted if this function is called.
	 * 
	 * A monoflop can be used as a failsafe mechanism. For example: Lets assume you
	 * have a RS485 bus and a IO-4 Bricklet is connected to one of the slave
	 * stacks. You can now call this function every second, with a time parameter
	 * of two seconds. The channel will be *high* all the time. If now the RS485
	 * connection is lost, the channel will turn *low* in at most two seconds.
	 */
	public void setMonoflop(int channel, boolean value, long time) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)14, FUNCTION_SET_MONOFLOP, this);

		bb.put((byte)channel);
		bb.put((byte)(value ? 1 : 0));
		bb.putInt((int)time);

		sendRequest(bb.array());
	}

	/**
	 * Returns (for the given channel) the current value and the time as set by
	 * {@link BrickletIndustrialDigitalOut4V2#setMonoflop(int, boolean, long)} as well as the remaining time until the value flips.
	 * 
	 * If the timer is not running currently, the remaining time will be returned
	 * as 0.
	 */
	public Monoflop getMonoflop(int channel) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_MONOFLOP, this);

		bb.put((byte)channel);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Monoflop obj = new Monoflop();
		obj.value = (bb.get()) != 0;
		obj.time = IPConnection.unsignedInt(bb.getInt());
		obj.timeRemaining = IPConnection.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Each channel has a corresponding LED. You can turn the LED off, on or show a
	 * heartbeat. You can also set the LED to "Channel Status". In this mode the
	 * LED is on if the channel is high and off otherwise.
	 * 
	 * By default all channel LEDs are configured as "Channel Status".
	 */
	public void setChannelLEDConfig(int channel, int config) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_CHANNEL_LED_CONFIG, this);

		bb.put((byte)channel);
		bb.put((byte)config);

		sendRequest(bb.array());
	}

	/**
	 * Returns the channel LED configuration as set by {@link BrickletIndustrialDigitalOut4V2#setChannelLEDConfig(int, int)}
	 */
	public int getChannelLEDConfig(int channel) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_CHANNEL_LED_CONFIG, this);

		bb.put((byte)channel);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int config = IPConnection.unsignedByte(bb.get());

		return config;
	}

	/**
	 * Activates a PWM for the given channel.
	 * 
	 * To turn the PWM off again, you can set the frequency to 0 or any other
	 * function that changes a value of the channel (e.g. {@link BrickletIndustrialDigitalOut4V2#setSelectedValue(int, boolean)}).
	 * 
	 * The optocoupler of the Industrial Digital
	 * Out 4 Bricklet 2.0 has a rise time and fall time of 11.5us (each) at 24V. So the maximum
	 * useful frequency value is about 400000 (40kHz).
	 * 
	 * A running monoflop timer for the given channel will be aborted if this function
	 * is called.
	 */
	public void setPWMConfiguration(int channel, long frequency, int dutyCycle) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)15, FUNCTION_SET_PWM_CONFIGURATION, this);

		bb.put((byte)channel);
		bb.putInt((int)frequency);
		bb.putShort((short)dutyCycle);

		sendRequest(bb.array());
	}

	/**
	 * Returns the PWM configuration as set by {@link BrickletIndustrialDigitalOut4V2#setPWMConfiguration(int, long, int)}.
	 */
	public PWMConfiguration getPWMConfiguration(int channel) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_PWM_CONFIGURATION, this);

		bb.put((byte)channel);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		PWMConfiguration obj = new PWMConfiguration();
		obj.frequency = IPConnection.unsignedInt(bb.getInt());
		obj.dutyCycle = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Returns the error count for the communication between Brick and Bricklet.
	 * 
	 * The errors are divided into
	 * 
	 * * ACK checksum errors,
	 * * message checksum errors,
	 * * framing errors and
	 * * overflow errors.
	 * 
	 * The errors counts are for errors that occur on the Bricklet side. All
	 * Bricks have a similar function that returns the errors on the Brick side.
	 */
	public SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_SPITFP_ERROR_COUNT, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		SPITFPErrorCount obj = new SPITFPErrorCount();
		obj.errorCountAckChecksum = IPConnection.unsignedInt(bb.getInt());
		obj.errorCountMessageChecksum = IPConnection.unsignedInt(bb.getInt());
		obj.errorCountFrame = IPConnection.unsignedInt(bb.getInt());
		obj.errorCountOverflow = IPConnection.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Sets the bootloader mode and returns the status after the requested
	 * mode change was instigated.
	 * 
	 * You can change from bootloader mode to firmware mode and vice versa. A change
	 * from bootloader mode to firmware mode will only take place if the entry function,
	 * device identifier and CRC are present and correct.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int setBootloaderMode(int mode) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_BOOTLOADER_MODE, this);

		bb.put((byte)mode);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnection.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Returns the current bootloader mode, see {@link BrickletIndustrialDigitalOut4V2#setBootloaderMode(int)}.
	 */
	public int getBootloaderMode() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_BOOTLOADER_MODE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int mode = IPConnection.unsignedByte(bb.get());

		return mode;
	}

	/**
	 * Sets the firmware pointer for {@link BrickletIndustrialDigitalOut4V2#writeFirmware(int[])}. The pointer has
	 * to be increased by chunks of size 64. The data is written to flash
	 * every 4 chunks (which equals to one page of size 256).
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_WRITE_FIRMWARE_POINTER, this);

		bb.putInt((int)pointer);

		sendRequest(bb.array());
	}

	/**
	 * Writes 64 Bytes of firmware at the position as written by
	 * {@link BrickletIndustrialDigitalOut4V2#setWriteFirmwarePointer(long)} before. The firmware is written
	 * to flash every 4 chunks.
	 * 
	 * You can only write firmware in bootloader mode.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int writeFirmware(int[] data) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)72, FUNCTION_WRITE_FIRMWARE, this);

		for (int i = 0; i < 64; i++) {
			bb.put((byte)data[i]);
		}

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnection.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Sets the status LED configuration. By default the LED shows
	 * communication traffic between Brick and Bricklet, it flickers once
	 * for every 10 received data packets.
	 * 
	 * You can also turn the LED permanently on/off or show a heartbeat.
	 * 
	 * If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
	 */
	public void setStatusLEDConfig(int config) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_STATUS_LED_CONFIG, this);

		bb.put((byte)config);

		sendRequest(bb.array());
	}

	/**
	 * Returns the configuration as set by {@link BrickletIndustrialDigitalOut4V2#setStatusLEDConfig(int)}
	 */
	public int getStatusLEDConfig() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_STATUS_LED_CONFIG, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int config = IPConnection.unsignedByte(bb.get());

		return config;
	}

	/**
	 * Returns the temperature as measured inside the microcontroller. The
	 * value returned is not the ambient temperature!
	 * 
	 * The temperature is only proportional to the real temperature and it has bad
	 * accuracy. Practically it is only useful as an indicator for
	 * temperature changes.
	 */
	public int getChipTemperature() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CHIP_TEMPERATURE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int temperature = (bb.getShort());

		return temperature;
	}

	/**
	 * Calling this function will reset the Bricklet. All configurations
	 * will be lost.
	 * 
	 * After a reset you have to create new device objects,
	 * calling functions on the existing ones will result in
	 * undefined behavior!
	 */
	public void reset() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_RESET, this);


		sendRequest(bb.array());
	}

	/**
	 * Writes a new UID into flash. If you want to set a new UID
	 * you have to decode the Base58 encoded UID string into an
	 * integer first.
	 * 
	 * We recommend that you use Brick Viewer to change the UID.
	 */
	public void writeUID(long uid) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_WRITE_UID, this);

		bb.putInt((int)uid);

		sendRequest(bb.array());
	}

	/**
	 * Returns the current UID as an integer. Encode as
	 * Base58 to get the usual string version.
	 */
	public long readUID() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_READ_UID, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long uid = IPConnection.unsignedInt(bb.getInt());

		return uid;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
	 * The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
	 * connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always as
	 * position 'z'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnection.string(bb, 8);
		obj.connectedUid = IPConnection.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Adds a MonoflopDone listener.
	 */
	public void addMonoflopDoneListener(MonoflopDoneListener listener) {
		listenerMonoflopDone.add(listener);
	}

	/**
	 * Removes a MonoflopDone listener.
	 */
	public void removeMonoflopDoneListener(MonoflopDoneListener listener) {
		listenerMonoflopDone.remove(listener);
	}

    private final Logger logger = LoggerFactory.getLogger(BrickletIndustrialDigitalOut4V2.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletIndustrialDigitalOut4V2.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletIndustrialDigitalOut4V2Config cfg = (BrickletIndustrialDigitalOut4V2Config) config.as(BrickletIndustrialDigitalOut4V2Config.class);
        this.addMonoflopDoneListener((channel, value) -> {if(channel == 0) {updateStateFn.accept("BrickletIndustrialDigitalOut4V2OutputPin0", transformBrickletIndustrialDigitalOut4V2OutputPin0Callback0(channel, value, cfg));}});
		this.addMonoflopDoneListener((channel, value) -> {if(channel == 1) {updateStateFn.accept("BrickletIndustrialDigitalOut4V2OutputPin1", transformBrickletIndustrialDigitalOut4V2OutputPin1Callback0(channel, value, cfg));}});
		this.addMonoflopDoneListener((channel, value) -> {if(channel == 2) {updateStateFn.accept("BrickletIndustrialDigitalOut4V2OutputPin2", transformBrickletIndustrialDigitalOut4V2OutputPin2Callback0(channel, value, cfg));}});
		this.addMonoflopDoneListener((channel, value) -> {if(channel == 3) {updateStateFn.accept("BrickletIndustrialDigitalOut4V2OutputPin3", transformBrickletIndustrialDigitalOut4V2OutputPin3Callback0(channel, value, cfg));}});
        
		this.setStatusLEDConfig(cfg.statusLEDConfig);
		{
		BrickletIndustrialDigitalOut4V2OutputPinConfig channelCfg = getChannelConfigFn.apply("BrickletIndustrialDigitalOut4V2OutputPin0").as(BrickletIndustrialDigitalOut4V2OutputPinConfig.class);
		this.setChannelLEDConfig(0, channelCfg.ledConfig);
		}
		{
		BrickletIndustrialDigitalOut4V2OutputPinConfig channelCfg = getChannelConfigFn.apply("BrickletIndustrialDigitalOut4V2OutputPin1").as(BrickletIndustrialDigitalOut4V2OutputPinConfig.class);
		this.setChannelLEDConfig(1, channelCfg.ledConfig);
		}
		{
		BrickletIndustrialDigitalOut4V2OutputPinConfig channelCfg = getChannelConfigFn.apply("BrickletIndustrialDigitalOut4V2OutputPin2").as(BrickletIndustrialDigitalOut4V2OutputPinConfig.class);
		this.setChannelLEDConfig(2, channelCfg.ledConfig);
		}
		{
		BrickletIndustrialDigitalOut4V2OutputPinConfig channelCfg = getChannelConfigFn.apply("BrickletIndustrialDigitalOut4V2OutputPin3").as(BrickletIndustrialDigitalOut4V2OutputPinConfig.class);
		this.setChannelLEDConfig(3, channelCfg.ledConfig);
		}
		{
		BrickletIndustrialDigitalOut4V2MonoflopConfig channelCfg = getChannelConfigFn.apply("BrickletIndustrialDigitalOut4V2MonoflopPin0").as(BrickletIndustrialDigitalOut4V2MonoflopConfig.class);
		
		}
		{
		BrickletIndustrialDigitalOut4V2MonoflopConfig channelCfg = getChannelConfigFn.apply("BrickletIndustrialDigitalOut4V2MonoflopPin1").as(BrickletIndustrialDigitalOut4V2MonoflopConfig.class);
		
		}
		{
		BrickletIndustrialDigitalOut4V2MonoflopConfig channelCfg = getChannelConfigFn.apply("BrickletIndustrialDigitalOut4V2MonoflopPin2").as(BrickletIndustrialDigitalOut4V2MonoflopConfig.class);
		
		}
		{
		BrickletIndustrialDigitalOut4V2MonoflopConfig channelCfg = getChannelConfigFn.apply("BrickletIndustrialDigitalOut4V2MonoflopPin3").as(BrickletIndustrialDigitalOut4V2MonoflopConfig.class);
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        BrickletIndustrialDigitalOut4V2Config cfg = (BrickletIndustrialDigitalOut4V2Config) config.as(BrickletIndustrialDigitalOut4V2Config.class);
        this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
        
		
		
		
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletIndustrialDigitalOut4V2Config cfg = (BrickletIndustrialDigitalOut4V2Config) config.as(BrickletIndustrialDigitalOut4V2Config.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletIndustrialDigitalOut4V2OutputPin0");
		result.add("BrickletIndustrialDigitalOut4V2OutputPin1");
		result.add("BrickletIndustrialDigitalOut4V2OutputPin2");
		result.add("BrickletIndustrialDigitalOut4V2OutputPin3");
		result.add("BrickletIndustrialDigitalOut4V2MonoflopPin0");
		result.add("BrickletIndustrialDigitalOut4V2MonoflopPin1");
		result.add("BrickletIndustrialDigitalOut4V2MonoflopPin2");
		result.add("BrickletIndustrialDigitalOut4V2MonoflopPin3");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletIndustrialDigitalOut4V2OutputPin":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletIndustrialDigitalOut4V2OutputPin"), "Output Value", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletIndustrialDigitalOut4V2OutputPin")).withDescription("The logic level that is currently set on the pin.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(false).build().toStateDescription()).build();
            case "BrickletIndustrialDigitalOut4V2Monoflop":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletIndustrialDigitalOut4V2Monoflop"), "NOT USED", "String").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletIndustrialDigitalOut4V2Monoflop")).withDescription("Triggers a monoflop as configured")
.withCommandDescription(CommandDescriptionBuilder.create().withCommandOption(new CommandOption("TRIGGER", "Trigger")).build()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Industrial Digital Out 4 Bricklet 2.0").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("4 galvanically isolated digital outputs").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletIndustrialDigitalOut4V2OutputPin0", new ChannelTypeUID("tinkerforge", "BrickletIndustrialDigitalOut4V2OutputPin")).withLabel("Output Value (Pin 0)").build(), new ChannelDefinitionBuilder("BrickletIndustrialDigitalOut4V2OutputPin1", new ChannelTypeUID("tinkerforge", "BrickletIndustrialDigitalOut4V2OutputPin")).withLabel("Output Value (Pin 1)").build(), new ChannelDefinitionBuilder("BrickletIndustrialDigitalOut4V2OutputPin2", new ChannelTypeUID("tinkerforge", "BrickletIndustrialDigitalOut4V2OutputPin")).withLabel("Output Value (Pin 2)").build(), new ChannelDefinitionBuilder("BrickletIndustrialDigitalOut4V2OutputPin3", new ChannelTypeUID("tinkerforge", "BrickletIndustrialDigitalOut4V2OutputPin")).withLabel("Output Value (Pin 3)").build(), new ChannelDefinitionBuilder("BrickletIndustrialDigitalOut4V2MonoflopPin0", new ChannelTypeUID("tinkerforge", "BrickletIndustrialDigitalOut4V2Monoflop")).withLabel("Monoflop Pin 0").build(), new ChannelDefinitionBuilder("BrickletIndustrialDigitalOut4V2MonoflopPin1", new ChannelTypeUID("tinkerforge", "BrickletIndustrialDigitalOut4V2Monoflop")).withLabel("Monoflop Pin 1").build(), new ChannelDefinitionBuilder("BrickletIndustrialDigitalOut4V2MonoflopPin2", new ChannelTypeUID("tinkerforge", "BrickletIndustrialDigitalOut4V2Monoflop")).withLabel("Monoflop Pin 2").build(), new ChannelDefinitionBuilder("BrickletIndustrialDigitalOut4V2MonoflopPin3", new ChannelTypeUID("tinkerforge", "BrickletIndustrialDigitalOut4V2Monoflop")).withLabel("Monoflop Pin 3").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletindustrialdigitalout4v2":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.INTEGER).withDefault("3").withDescription("The status LED configuration. By default the LED shows communication traffic between Brick and Bricklet, it flickers once for every 10 received data packets.<br/><br/>You can also turn the LED permanently on/off or show a heartbeat.<br/><br/>If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.").withLabel("Status LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Status"))).build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletIndustrialDigitalOut4V2OutputPin":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("ledConfig", Type.INTEGER).withDefault("3").withDescription("Each channel has a corresponding LED. You can turn the LED off, on or show a heartbeat. You can also set the LED to \"Channel Status\". In this mode the LED is on if the channel is high and off otherwise.").withLabel("LED Configuration").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Channel Status"))).build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletIndustrialDigitalOut4V2Monoflop":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("monoflopDuration", Type.INTEGER).withDefault("1000").withDescription("The time (in ms) that the pin should hold the configured value.").withLabel("Monoflop Duration").withUnit("ms").withAdvanced(true).withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(4294967295L)).build(), ConfigDescriptionParameterBuilder.create("monoflopValue", Type.BOOLEAN).withDefault("true").withDescription("The desired value of the specified channel. Activated means relay closed and Deactivated means relay open.").withLabel("Monoflop Value").withAdvanced(true).build())).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletIndustrialDigitalOut4V2Config cfg = (BrickletIndustrialDigitalOut4V2Config) config.as(BrickletIndustrialDigitalOut4V2Config.class);
        switch(channel) {
            case "BrickletIndustrialDigitalOut4V2OutputPin0": {
                   BrickletIndustrialDigitalOut4V2OutputPinConfig channelCfg = channelConfig.as(BrickletIndustrialDigitalOut4V2OutputPinConfig.class);
                   {
            boolean[] value = this.getValue();
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialDigitalOut4V2OutputPin0Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIndustrialDigitalOut4V2OutputPin1": {
                   BrickletIndustrialDigitalOut4V2OutputPinConfig channelCfg = channelConfig.as(BrickletIndustrialDigitalOut4V2OutputPinConfig.class);
                   {
            boolean[] value = this.getValue();
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialDigitalOut4V2OutputPin1Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIndustrialDigitalOut4V2OutputPin2": {
                   BrickletIndustrialDigitalOut4V2OutputPinConfig channelCfg = channelConfig.as(BrickletIndustrialDigitalOut4V2OutputPinConfig.class);
                   {
            boolean[] value = this.getValue();
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialDigitalOut4V2OutputPin2Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIndustrialDigitalOut4V2OutputPin3": {
                   BrickletIndustrialDigitalOut4V2OutputPinConfig channelCfg = channelConfig.as(BrickletIndustrialDigitalOut4V2OutputPinConfig.class);
                   {
            boolean[] value = this.getValue();
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialDigitalOut4V2OutputPin3Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIndustrialDigitalOut4V2MonoflopPin0": {
                   BrickletIndustrialDigitalOut4V2MonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialDigitalOut4V2MonoflopConfig.class);
                   {
            Monoflop value = this.getMonoflop(0);
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialDigitalOut4V2MonoflopPin0Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIndustrialDigitalOut4V2MonoflopPin1": {
                   BrickletIndustrialDigitalOut4V2MonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialDigitalOut4V2MonoflopConfig.class);
                   {
            Monoflop value = this.getMonoflop(1);
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialDigitalOut4V2MonoflopPin1Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIndustrialDigitalOut4V2MonoflopPin2": {
                   BrickletIndustrialDigitalOut4V2MonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialDigitalOut4V2MonoflopConfig.class);
                   {
            Monoflop value = this.getMonoflop(2);
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialDigitalOut4V2MonoflopPin2Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIndustrialDigitalOut4V2MonoflopPin3": {
                   BrickletIndustrialDigitalOut4V2MonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialDigitalOut4V2MonoflopConfig.class);
                   {
            Monoflop value = this.getMonoflop(3);
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialDigitalOut4V2MonoflopPin3Getter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = new ArrayList<SetterRefresh>();
        BrickletIndustrialDigitalOut4V2Config cfg = (BrickletIndustrialDigitalOut4V2Config) config.as(BrickletIndustrialDigitalOut4V2Config.class);
        switch(channel) {
            case "BrickletIndustrialDigitalOut4V2OutputPin0":
                if (command instanceof OnOffType) {
                    BrickletIndustrialDigitalOut4V2OutputPinConfig channelCfg = channelConfig.as(BrickletIndustrialDigitalOut4V2OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValue(0, cmd == OnOffType.ON);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletIndustrialDigitalOut4V2OutputPin1":
                if (command instanceof OnOffType) {
                    BrickletIndustrialDigitalOut4V2OutputPinConfig channelCfg = channelConfig.as(BrickletIndustrialDigitalOut4V2OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValue(1, cmd == OnOffType.ON);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletIndustrialDigitalOut4V2OutputPin2":
                if (command instanceof OnOffType) {
                    BrickletIndustrialDigitalOut4V2OutputPinConfig channelCfg = channelConfig.as(BrickletIndustrialDigitalOut4V2OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValue(2, cmd == OnOffType.ON);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletIndustrialDigitalOut4V2OutputPin3":
                if (command instanceof OnOffType) {
                    BrickletIndustrialDigitalOut4V2OutputPinConfig channelCfg = channelConfig.as(BrickletIndustrialDigitalOut4V2OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValue(3, cmd == OnOffType.ON);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletIndustrialDigitalOut4V2MonoflopPin0":
                if (command instanceof StringType) {
                    BrickletIndustrialDigitalOut4V2MonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialDigitalOut4V2MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(0, channelCfg.monoflopValue.booleanValue(), channelCfg.monoflopDuration.longValue());
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                result.add(new SetterRefresh("BrickletIndustrialDigitalOut4V2OutputPin0", 0));
                break;
            case "BrickletIndustrialDigitalOut4V2MonoflopPin1":
                if (command instanceof StringType) {
                    BrickletIndustrialDigitalOut4V2MonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialDigitalOut4V2MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(1, channelCfg.monoflopValue.booleanValue(), channelCfg.monoflopDuration.longValue());
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                result.add(new SetterRefresh("BrickletIndustrialDigitalOut4V2OutputPin1", 0));
                break;
            case "BrickletIndustrialDigitalOut4V2MonoflopPin2":
                if (command instanceof StringType) {
                    BrickletIndustrialDigitalOut4V2MonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialDigitalOut4V2MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(2, channelCfg.monoflopValue.booleanValue(), channelCfg.monoflopDuration.longValue());
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                result.add(new SetterRefresh("BrickletIndustrialDigitalOut4V2OutputPin2", 0));
                break;
            case "BrickletIndustrialDigitalOut4V2MonoflopPin3":
                if (command instanceof StringType) {
                    BrickletIndustrialDigitalOut4V2MonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialDigitalOut4V2MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(3, channelCfg.monoflopValue.booleanValue(), channelCfg.monoflopDuration.longValue());
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                result.add(new SetterRefresh("BrickletIndustrialDigitalOut4V2OutputPin3", 0));
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDigitalOut4V2OutputPin0Callback0(int channel, boolean value, BrickletIndustrialDigitalOut4V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDigitalOut4V2OutputPin1Callback0(int channel, boolean value, BrickletIndustrialDigitalOut4V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDigitalOut4V2OutputPin2Callback0(int channel, boolean value, BrickletIndustrialDigitalOut4V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDigitalOut4V2OutputPin3Callback0(int channel, boolean value, BrickletIndustrialDigitalOut4V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDigitalOut4V2OutputPin0Getter0(boolean[] value, BrickletIndustrialDigitalOut4V2Config cfg) {
        return value[0] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDigitalOut4V2OutputPin1Getter0(boolean[] value, BrickletIndustrialDigitalOut4V2Config cfg) {
        return value[1] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDigitalOut4V2OutputPin2Getter0(boolean[] value, BrickletIndustrialDigitalOut4V2Config cfg) {
        return value[2] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDigitalOut4V2OutputPin3Getter0(boolean[] value, BrickletIndustrialDigitalOut4V2Config cfg) {
        return value[3] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDigitalOut4V2MonoflopPin0Getter0(Monoflop value, BrickletIndustrialDigitalOut4V2Config cfg) {
        return value.value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDigitalOut4V2MonoflopPin1Getter0(Monoflop value, BrickletIndustrialDigitalOut4V2Config cfg) {
        return value.value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDigitalOut4V2MonoflopPin2Getter0(Monoflop value, BrickletIndustrialDigitalOut4V2Config cfg) {
        return value.value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDigitalOut4V2MonoflopPin3Getter0(Monoflop value, BrickletIndustrialDigitalOut4V2Config cfg) {
        return value.value ? OnOffType.ON : OnOffType.OFF;
    }
}
