/* ***********************************************************
 * This file was automatically generated on 2020-01-31.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;
import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.thing.CommonTriggerEvents;
import org.eclipse.smarthome.core.library.types.StringType;
import org.eclipse.smarthome.core.library.types.DecimalType;
import org.eclipse.smarthome.core.library.types.OnOffType;
import com.tinkerforge.Helper;

/**
 * 20x4 character alphanumeric display with blue backlight
 */
public class BrickletLCD20x4 extends Device {
	public final static int DEVICE_IDENTIFIER = 212;
	public final static String DEVICE_DISPLAY_NAME = "LCD 20x4 Bricklet";

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(DEVICE_DISPLAY_NAME, "brickletlcd20x4", DEVICE_IDENTIFIER, BrickletLCD20x4.class, BrickletLCD20x4Actions.class, "2.0.2");

	public final static byte FUNCTION_WRITE_LINE = (byte)1;
	public final static byte FUNCTION_CLEAR_DISPLAY = (byte)2;
	public final static byte FUNCTION_BACKLIGHT_ON = (byte)3;
	public final static byte FUNCTION_BACKLIGHT_OFF = (byte)4;
	public final static byte FUNCTION_IS_BACKLIGHT_ON = (byte)5;
	public final static byte FUNCTION_SET_CONFIG = (byte)6;
	public final static byte FUNCTION_GET_CONFIG = (byte)7;
	public final static byte FUNCTION_IS_BUTTON_PRESSED = (byte)8;
	public final static byte FUNCTION_SET_CUSTOM_CHARACTER = (byte)11;
	public final static byte FUNCTION_GET_CUSTOM_CHARACTER = (byte)12;
	public final static byte FUNCTION_SET_DEFAULT_TEXT = (byte)13;
	public final static byte FUNCTION_GET_DEFAULT_TEXT = (byte)14;
	public final static byte FUNCTION_SET_DEFAULT_TEXT_COUNTER = (byte)15;
	public final static byte FUNCTION_GET_DEFAULT_TEXT_COUNTER = (byte)16;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_BUTTON_PRESSED = 9;
	private final static int CALLBACK_BUTTON_RELEASED = 10;


	private List<ButtonPressedListener> listenerButtonPressed = new CopyOnWriteArrayList<ButtonPressedListener>();
	private List<ButtonReleasedListener> listenerButtonReleased = new CopyOnWriteArrayList<ButtonReleasedListener>();

	public class Config {
		public boolean cursor;
		public boolean blinking;

		public String toString() {
			return "[" + "cursor = " + cursor + ", " + "blinking = " + blinking + "]";
		}
	}

	/**
	 * This listener is triggered when a button is pressed. The parameter is
	 * the number of the button (0 to 2 or 0 to 3 since hardware version 1.2).
	 */
	public interface ButtonPressedListener extends DeviceListener {
		public void buttonPressed(int button);
	}

	/**
	 * This listener is triggered when a button is released. The parameter is
	 * the number of the button (0 to 2 or 0 to 3 since hardware version 1.2).
	 */
	public interface ButtonReleasedListener extends DeviceListener {
		public void buttonReleased(int button);
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletLCD20x4(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 2;

		deviceIdentifier = DEVICE_IDENTIFIER;
		deviceDisplayName = DEVICE_DISPLAY_NAME;

		responseExpected[IPConnection.unsignedByte(FUNCTION_WRITE_LINE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_CLEAR_DISPLAY)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_BACKLIGHT_ON)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_BACKLIGHT_OFF)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_IS_BACKLIGHT_ON)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_IS_BUTTON_PRESSED)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_CUSTOM_CHARACTER)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CUSTOM_CHARACTER)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_DEFAULT_TEXT)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_DEFAULT_TEXT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_DEFAULT_TEXT_COUNTER)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_DEFAULT_TEXT_COUNTER)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_BUTTON_PRESSED] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int button = IPConnection.unsignedByte(bb.get());

				for (ButtonPressedListener listener: listenerButtonPressed) {
					listener.buttonPressed(button);
				}
			}
		};

		callbacks[CALLBACK_BUTTON_RELEASED] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int button = IPConnection.unsignedByte(bb.get());

				for (ButtonReleasedListener listener: listenerButtonReleased) {
					listener.buttonReleased(button);
				}
			}
		};

		ipcon.addDevice(this);
	}

	/**
	 * Writes text to a specific line with a specific position.
	 * The text can have a maximum of 20 characters.
	 * 
	 * For example: (0, 7, "Hello") will write *Hello* in the middle of the
	 * first line of the display.
	 * 
	 * The display uses a special charset that includes all ASCII characters except
	 * backslash and tilde. The LCD charset also includes several other non-ASCII characters, see
	 * the `charset specification &lt;https://github.com/Tinkerforge/lcd-20x4-bricklet/raw/master/datasheets/standard_charset.pdf&gt;`__
	 * for details. The Unicode example above shows how to specify non-ASCII characters
	 * and how to translate from Unicode to the LCD charset.
	 */
	public void writeLine(int line, int position, String text) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)30, FUNCTION_WRITE_LINE, this);

		bb.put((byte)line);
		bb.put((byte)position);
		for (int i = 0; i < 20; i++) {
			try {
				bb.put((byte)text.charAt(i));
			} catch(Exception e) {
				bb.put((byte)0);
			}
		}

		sendRequest(bb.array());
	}

	/**
	 * Deletes all characters from the display.
	 */
	public void clearDisplay() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_CLEAR_DISPLAY, this);


		sendRequest(bb.array());
	}

	/**
	 * Turns the backlight on.
	 */
	public void backlightOn() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_BACKLIGHT_ON, this);


		sendRequest(bb.array());
	}

	/**
	 * Turns the backlight off.
	 */
	public void backlightOff() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_BACKLIGHT_OFF, this);


		sendRequest(bb.array());
	}

	/**
	 * Returns *true* if the backlight is on and *false* otherwise.
	 */
	public boolean isBacklightOn() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_IS_BACKLIGHT_ON, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		boolean backlight = (bb.get()) != 0;

		return backlight;
	}

	/**
	 * Configures if the cursor (shown as "_") should be visible and if it
	 * should be blinking (shown as a blinking block). The cursor position
	 * is one character behind the the last text written with
	 * {@link BrickletLCD20x4#writeLine(int, int, String)}.
	 */
	public void setConfig(boolean cursor, boolean blinking) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_CONFIG, this);

		bb.put((byte)(cursor ? 1 : 0));
		bb.put((byte)(blinking ? 1 : 0));

		sendRequest(bb.array());
	}

	/**
	 * Returns the configuration as set by {@link BrickletLCD20x4#setConfig(boolean, boolean)}.
	 */
	public Config getConfig() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CONFIG, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Config obj = new Config();
		obj.cursor = (bb.get()) != 0;
		obj.blinking = (bb.get()) != 0;

		return obj;
	}

	/**
	 * Returns *true* if the button (0 to 2 or 0 to 3 since hardware version 1.2)
	 * is pressed.
	 * 
	 * If you want to react on button presses and releases it is recommended to use
	 * the {@link BrickletLCD20x4.ButtonPressedListener} and {@link BrickletLCD20x4.ButtonReleasedListener} listeners.
	 */
	public boolean isButtonPressed(int button) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_IS_BUTTON_PRESSED, this);

		bb.put((byte)button);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		boolean pressed = (bb.get()) != 0;

		return pressed;
	}

	/**
	 * The LCD 20x4 Bricklet can store up to 8 custom characters. The characters
	 * consist of 5x8 pixels and can be addressed with the index 0-7. To describe
	 * the pixels, the first 5 bits of 8 bytes are used. For example, to make
	 * a custom character "H", you should transfer the following:
	 * 
	 * * ``character[0] = 0b00010001`` (decimal value 17)
	 * * ``character[1] = 0b00010001`` (decimal value 17)
	 * * ``character[2] = 0b00010001`` (decimal value 17)
	 * * ``character[3] = 0b00011111`` (decimal value 31)
	 * * ``character[4] = 0b00010001`` (decimal value 17)
	 * * ``character[5] = 0b00010001`` (decimal value 17)
	 * * ``character[6] = 0b00010001`` (decimal value 17)
	 * * ``character[7] = 0b00000000`` (decimal value 0)
	 * 
	 * The characters can later be written with {@link BrickletLCD20x4#writeLine(int, int, String)} by using the
	 * characters with the byte representation 8 ("\\x08" or "\\u0008") to 15
	 * ("\\x0F" or "\\u000F").
	 * 
	 * You can play around with the custom characters in Brick Viewer version
	 * since 2.0.1.
	 * 
	 * Custom characters are stored by the LCD in RAM, so they have to be set
	 * after each startup.
	 * 
	 * .. versionadded:: 2.0.1$nbsp;(Plugin)
	 */
	public void setCustomCharacter(int index, int[] character) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)17, FUNCTION_SET_CUSTOM_CHARACTER, this);

		bb.put((byte)index);
		for (int i = 0; i < 8; i++) {
			bb.put((byte)character[i]);
		}

		sendRequest(bb.array());
	}

	/**
	 * Returns the custom character for a given index, as set with
	 * {@link BrickletLCD20x4#setCustomCharacter(int, int[])}.
	 * 
	 * .. versionadded:: 2.0.1$nbsp;(Plugin)
	 */
	public int[] getCustomCharacter(int index) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_CUSTOM_CHARACTER, this);

		bb.put((byte)index);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int[] character = new int[8];
		for (int i = 0; i < 8; i++) {
			character[i] = IPConnection.unsignedByte(bb.get());
		}

		return character;
	}

	/**
	 * Sets the default text for lines 0-3. The max number of characters
	 * per line is 20.
	 * 
	 * The default text is shown on the LCD, if the default text counter
	 * expires, see {@link BrickletLCD20x4#setDefaultTextCounter(int)}.
	 * 
	 * .. versionadded:: 2.0.2$nbsp;(Plugin)
	 */
	public void setDefaultText(int line, String text) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)29, FUNCTION_SET_DEFAULT_TEXT, this);

		bb.put((byte)line);
		for (int i = 0; i < 20; i++) {
			try {
				bb.put((byte)text.charAt(i));
			} catch(Exception e) {
				bb.put((byte)0);
			}
		}

		sendRequest(bb.array());
	}

	/**
	 * Returns the default text for a given line (0-3) as set by
	 * {@link BrickletLCD20x4#setDefaultText(int, String)}.
	 * 
	 * .. versionadded:: 2.0.2$nbsp;(Plugin)
	 */
	public String getDefaultText(int line) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_DEFAULT_TEXT, this);

		bb.put((byte)line);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		String text = IPConnection.string(bb, 20);

		return text;
	}

	/**
	 * Sets the default text counter. This counter is decremented each
	 * ms by the LCD firmware. If the counter reaches 0, the default text
	 * (see {@link BrickletLCD20x4#setDefaultText(int, String)}) is shown on the LCD.
	 * 
	 * This functionality can be used to show a default text if the controlling
	 * program crashes or the connection is interrupted.
	 * 
	 * A possible approach is to call {@link BrickletLCD20x4#setDefaultTextCounter(int)} every
	 * minute with the parameter 1000*60*2 (2 minutes). In this case the
	 * default text will be shown no later than 2 minutes after the
	 * controlling program crashes.
	 * 
	 * A negative counter turns the default text functionality off.
	 * 
	 * .. versionadded:: 2.0.2$nbsp;(Plugin)
	 */
	public void setDefaultTextCounter(int counter) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_DEFAULT_TEXT_COUNTER, this);

		bb.putInt(counter);

		sendRequest(bb.array());
	}

	/**
	 * Returns the current value of the default text counter.
	 * 
	 * .. versionadded:: 2.0.2$nbsp;(Plugin)
	 */
	public int getDefaultTextCounter() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_DEFAULT_TEXT_COUNTER, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int counter = (bb.getInt());

		return counter;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
	 * The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
	 * connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always as
	 * position 'z'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnection.string(bb, 8);
		obj.connectedUid = IPConnection.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Adds a ButtonPressed listener.
	 */
	public void addButtonPressedListener(ButtonPressedListener listener) {
		listenerButtonPressed.add(listener);
	}

	/**
	 * Removes a ButtonPressed listener.
	 */
	public void removeButtonPressedListener(ButtonPressedListener listener) {
		listenerButtonPressed.remove(listener);
	}

	/**
	 * Adds a ButtonReleased listener.
	 */
	public void addButtonReleasedListener(ButtonReleasedListener listener) {
		listenerButtonReleased.add(listener);
	}

	/**
	 * Removes a ButtonReleased listener.
	 */
	public void removeButtonReleasedListener(ButtonReleasedListener listener) {
		listenerButtonReleased.remove(listener);
	}

    private final Logger logger = LoggerFactory.getLogger(BrickletLCD20x4.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletLCD20x4.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletLCD20x4Config cfg = (BrickletLCD20x4Config) config.as(BrickletLCD20x4Config.class);
        this.addButtonPressedListener((button) -> {if(button == 0) {triggerChannelFn.accept("BrickletLCD20x4Button0", transformBrickletLCD20x4Button0Callback0(button, cfg));}});
		this.addButtonReleasedListener((button) -> {if(button == 0) {triggerChannelFn.accept("BrickletLCD20x4Button0", transformBrickletLCD20x4Button0Callback1(button, cfg));}});
		this.addButtonPressedListener((button) -> {if(button == 1) {triggerChannelFn.accept("BrickletLCD20x4Button1", transformBrickletLCD20x4Button1Callback0(button, cfg));}});
		this.addButtonReleasedListener((button) -> {if(button == 1) {triggerChannelFn.accept("BrickletLCD20x4Button1", transformBrickletLCD20x4Button1Callback1(button, cfg));}});
		this.addButtonPressedListener((button) -> {if(button == 2) {triggerChannelFn.accept("BrickletLCD20x4Button2", transformBrickletLCD20x4Button2Callback0(button, cfg));}});
		this.addButtonReleasedListener((button) -> {if(button == 2) {triggerChannelFn.accept("BrickletLCD20x4Button2", transformBrickletLCD20x4Button2Callback1(button, cfg));}});
		if(this.getIdentity().hardwareVersion[1] >= 2) {
this.addButtonPressedListener((button) -> {if(button == 3) {triggerChannelFn.accept("BrickletLCD20x4Button3", transformBrickletLCD20x4Button3Callback0(button, cfg));}});}
		if(this.getIdentity().hardwareVersion[1] >= 2) {
this.addButtonReleasedListener((button) -> {if(button == 3) {triggerChannelFn.accept("BrickletLCD20x4Button3", transformBrickletLCD20x4Button3Callback1(button, cfg));}});}
        this.setConfig(cfg.showCursor, cfg.showBlinkingCursor);
		{
		BrickletLCD20x4TextConfig channelCfg = getChannelConfigFn.apply("BrickletLCD20x4Text").as(BrickletLCD20x4TextConfig.class);
		
		}
		{
		BrickletLCD20x4ClearDisplayConfig channelCfg = getChannelConfigFn.apply("BrickletLCD20x4ClearDisplay").as(BrickletLCD20x4ClearDisplayConfig.class);
		
		}
		{
		BrickletLCD20x4BacklightConfig channelCfg = getChannelConfigFn.apply("BrickletLCD20x4Backlight").as(BrickletLCD20x4BacklightConfig.class);
		
		}
		{
		
		}
		{
		
		}
		{
		
		}
		if (this.getIdentity().hardwareVersion[1] >= 2) {
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        BrickletLCD20x4Config cfg = (BrickletLCD20x4Config) config.as(BrickletLCD20x4Config.class);
        this.listenerButtonPressed.clear();
		this.listenerButtonReleased.clear();
		this.listenerButtonPressed.clear();
		this.listenerButtonReleased.clear();
		this.listenerButtonPressed.clear();
		this.listenerButtonReleased.clear();
		this.listenerButtonPressed.clear();
		this.listenerButtonReleased.clear();
        
		
		
		
		
		
		
		
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletLCD20x4Config cfg = (BrickletLCD20x4Config) config.as(BrickletLCD20x4Config.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletLCD20x4Text");
		result.add("BrickletLCD20x4ClearDisplay");
		result.add("BrickletLCD20x4Backlight");
		result.add("BrickletLCD20x4Button0");
		result.add("BrickletLCD20x4Button1");
		result.add("BrickletLCD20x4Button2");
		if (this.getIdentity().hardwareVersion[1] >= 2) {
                result.add("BrickletLCD20x4Button3");
            }
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletLCD20x4Text":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletLCD20x4Text"), "Text", "String").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletLCD20x4Text")).withDescription("Text to display on the LCD. Command format is [line],[position],[text].<br/><br/>Additional ',' are handled as part of the text. Unicode characters are converted to the LCD character set if possible. Additionally you can use \\x[two hex digits] to use a character of the LCD character set directly.").build();
            case "BrickletLCD20x4ClearDisplay":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletLCD20x4ClearDisplay"), "Clear Display", "String").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletLCD20x4ClearDisplay")).withDescription("Deletes all characters from the display.")
.withCommandDescription(CommandDescriptionBuilder.create().withCommandOption(new CommandOption("CLEAR", "Clear")).build()).build();
            case "BrickletLCD20x4Backlight":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletLCD20x4Backlight"), "Backlight", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletLCD20x4Backlight")).withDescription("Toggles the LCD's backlight").build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge LCD 20x4 Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("20x4 character alphanumeric display with blue backlight").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletLCD20x4Text", new ChannelTypeUID("tinkerforge", "BrickletLCD20x4Text")).withLabel("Text").build(), new ChannelDefinitionBuilder("BrickletLCD20x4ClearDisplay", new ChannelTypeUID("tinkerforge", "BrickletLCD20x4ClearDisplay")).withLabel("Clear Display").build(), new ChannelDefinitionBuilder("BrickletLCD20x4Backlight", new ChannelTypeUID("tinkerforge", "BrickletLCD20x4Backlight")).withLabel("Backlight").build(), new ChannelDefinitionBuilder("BrickletLCD20x4Button0", new ChannelTypeUID("system", "rawbutton")).withLabel("Button 0").build(), new ChannelDefinitionBuilder("BrickletLCD20x4Button1", new ChannelTypeUID("system", "rawbutton")).withLabel("Button 1").build(), new ChannelDefinitionBuilder("BrickletLCD20x4Button2", new ChannelTypeUID("system", "rawbutton")).withLabel("Button 2").build(), new ChannelDefinitionBuilder("BrickletLCD20x4Button3", new ChannelTypeUID("system", "rawbutton")).withLabel("Button 3").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletlcd20x4":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("showCursor", Type.BOOLEAN).withDefault("false").withDescription("Configures if the cursor (shown as '_') should be visible. The cursor position is one character behind the the last text written.").withLabel("Show Cursor").withAdvanced(true).build(), ConfigDescriptionParameterBuilder.create("showBlinkingCursor", Type.BOOLEAN).withDefault("false").withDescription("Configures if the blinking cursor (shown as a blinking block) should be visible. The cursor position is one character behind the the last text written.").withLabel("Show Blinking Cursor").withAdvanced(true).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletLCD20x4Text":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletLCD20x4ClearDisplay":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletLCD20x4Backlight":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletLCD20x4Config cfg = (BrickletLCD20x4Config) config.as(BrickletLCD20x4Config.class);
        switch(channel) {
            case "BrickletLCD20x4Text":
               return;
            case "BrickletLCD20x4ClearDisplay":
               return;
            case "BrickletLCD20x4Backlight": {
                   BrickletLCD20x4BacklightConfig channelCfg = channelConfig.as(BrickletLCD20x4BacklightConfig.class);
                   {
            boolean value = this.isBacklightOn();
            if(true)
                updateStateFn.accept(channel, transformBrickletLCD20x4BacklightGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletLCD20x4Button0":
                   {
            boolean value = this.isButtonPressed(0);
            if(true)
                triggerChannelFn.accept(channel, transformBrickletLCD20x4Button0Getter0(value, cfg));
        }
                   return;
            case "BrickletLCD20x4Button1":
                   {
            boolean value = this.isButtonPressed(1);
            if(true)
                triggerChannelFn.accept(channel, transformBrickletLCD20x4Button1Getter0(value, cfg));
        }
                   return;
            case "BrickletLCD20x4Button2":
                   {
            boolean value = this.isButtonPressed(2);
            if(true)
                triggerChannelFn.accept(channel, transformBrickletLCD20x4Button2Getter0(value, cfg));
        }
                   return;
            case "BrickletLCD20x4Button3":
                   {
            boolean value = this.isButtonPressed(3);
            if(true)
                triggerChannelFn.accept(channel, transformBrickletLCD20x4Button3Getter0(value, cfg));
        }
                   return;
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletLCD20x4Config cfg = (BrickletLCD20x4Config) config.as(BrickletLCD20x4Config.class);
        switch(channel) {
            case "BrickletLCD20x4Text":
                if (command instanceof StringType) {
                    BrickletLCD20x4TextConfig channelCfg = channelConfig.as(BrickletLCD20x4TextConfig.class);
                    StringType cmd = (StringType) command;
                    this.writeLine(Helper.parseDisplayCommandLine(cmd.toString(), logger), Helper.parseDisplayCommandPosition(cmd.toString(), logger), Helper.parseDisplayCommandText(cmd.toString(), logger, true));
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletLCD20x4ClearDisplay":
                if (command instanceof StringType) {
                    BrickletLCD20x4ClearDisplayConfig channelCfg = channelConfig.as(BrickletLCD20x4ClearDisplayConfig.class);
                    StringType cmd = (StringType) command;
                    this.clearDisplay();
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletLCD20x4Backlight":
                if (command instanceof OnOffType) {
                    BrickletLCD20x4BacklightConfig channelCfg = channelConfig.as(BrickletLCD20x4BacklightConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    if(cmd == OnOffType.ON) {
    this.backlightOn();
}
                }
        
if (command instanceof OnOffType) {
                    BrickletLCD20x4BacklightConfig channelCfg = channelConfig.as(BrickletLCD20x4BacklightConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    if(cmd == OnOffType.OFF) {
    this.backlightOff();
}
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType, OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private String transformBrickletLCD20x4Button0Callback0(int button, BrickletLCD20x4Config cfg) {
        return CommonTriggerEvents.PRESSED;
    }
	    private String transformBrickletLCD20x4Button0Callback1(int button, BrickletLCD20x4Config cfg) {
        return CommonTriggerEvents.RELEASED;
    }
	    private String transformBrickletLCD20x4Button1Callback0(int button, BrickletLCD20x4Config cfg) {
        return CommonTriggerEvents.PRESSED;
    }
	    private String transformBrickletLCD20x4Button1Callback1(int button, BrickletLCD20x4Config cfg) {
        return CommonTriggerEvents.RELEASED;
    }
	    private String transformBrickletLCD20x4Button2Callback0(int button, BrickletLCD20x4Config cfg) {
        return CommonTriggerEvents.PRESSED;
    }
	    private String transformBrickletLCD20x4Button2Callback1(int button, BrickletLCD20x4Config cfg) {
        return CommonTriggerEvents.RELEASED;
    }
	    private String transformBrickletLCD20x4Button3Callback0(int button, BrickletLCD20x4Config cfg) {
        return CommonTriggerEvents.PRESSED;
    }
	    private String transformBrickletLCD20x4Button3Callback1(int button, BrickletLCD20x4Config cfg) {
        return CommonTriggerEvents.RELEASED;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletLCD20x4BacklightGetter0(boolean value, BrickletLCD20x4Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private String transformBrickletLCD20x4Button0Getter0(boolean value, BrickletLCD20x4Config cfg) {
        return value ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }
	    private String transformBrickletLCD20x4Button1Getter0(boolean value, BrickletLCD20x4Config cfg) {
        return value ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }
	    private String transformBrickletLCD20x4Button2Getter0(boolean value, BrickletLCD20x4Config cfg) {
        return value ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }
	    private String transformBrickletLCD20x4Button3Getter0(boolean value, BrickletLCD20x4Config cfg) {
        return value ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }
}
