/* ***********************************************************
 * This file was automatically generated on 2020-01-31.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;
import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.library.types.OnOffType;
import org.eclipse.smarthome.core.library.types.DecimalType;

/**
 * Controls remote mains switches and receives signals from remotes
 */
public class BrickletRemoteSwitchV2 extends Device {
	public final static int DEVICE_IDENTIFIER = 289;
	public final static String DEVICE_DISPLAY_NAME = "Remote Switch Bricklet 2.0";

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(DEVICE_DISPLAY_NAME, "brickletremoteswitchv2", DEVICE_IDENTIFIER, BrickletRemoteSwitchV2.class, BrickletRemoteSwitchV2Actions.class, "2.0.0");

	public final static byte FUNCTION_GET_SWITCHING_STATE = (byte)1;
	public final static byte FUNCTION_SET_REPEATS = (byte)3;
	public final static byte FUNCTION_GET_REPEATS = (byte)4;
	public final static byte FUNCTION_SWITCH_SOCKET_A = (byte)5;
	public final static byte FUNCTION_SWITCH_SOCKET_B = (byte)6;
	public final static byte FUNCTION_DIM_SOCKET_B = (byte)7;
	public final static byte FUNCTION_SWITCH_SOCKET_C = (byte)8;
	public final static byte FUNCTION_SET_REMOTE_CONFIGURATION = (byte)9;
	public final static byte FUNCTION_GET_REMOTE_CONFIGURATION = (byte)10;
	public final static byte FUNCTION_GET_REMOTE_STATUS_A = (byte)11;
	public final static byte FUNCTION_GET_REMOTE_STATUS_B = (byte)12;
	public final static byte FUNCTION_GET_REMOTE_STATUS_C = (byte)13;
	public final static byte FUNCTION_GET_SPITFP_ERROR_COUNT = (byte)234;
	public final static byte FUNCTION_SET_BOOTLOADER_MODE = (byte)235;
	public final static byte FUNCTION_GET_BOOTLOADER_MODE = (byte)236;
	public final static byte FUNCTION_SET_WRITE_FIRMWARE_POINTER = (byte)237;
	public final static byte FUNCTION_WRITE_FIRMWARE = (byte)238;
	public final static byte FUNCTION_SET_STATUS_LED_CONFIG = (byte)239;
	public final static byte FUNCTION_GET_STATUS_LED_CONFIG = (byte)240;
	public final static byte FUNCTION_GET_CHIP_TEMPERATURE = (byte)242;
	public final static byte FUNCTION_RESET = (byte)243;
	public final static byte FUNCTION_WRITE_UID = (byte)248;
	public final static byte FUNCTION_READ_UID = (byte)249;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_SWITCHING_DONE = 2;
	private final static int CALLBACK_REMOTE_STATUS_A = 14;
	private final static int CALLBACK_REMOTE_STATUS_B = 15;
	private final static int CALLBACK_REMOTE_STATUS_C = 16;

	public final static int SWITCHING_STATE_READY = 0;
	public final static int SWITCHING_STATE_BUSY = 1;
	public final static int SWITCH_TO_OFF = 0;
	public final static int SWITCH_TO_ON = 1;
	public final static int REMOTE_TYPE_A = 0;
	public final static int REMOTE_TYPE_B = 1;
	public final static int REMOTE_TYPE_C = 2;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;

	private List<SwitchingDoneListener> listenerSwitchingDone = new CopyOnWriteArrayList<SwitchingDoneListener>();
	private List<RemoteStatusAListener> listenerRemoteStatusA = new CopyOnWriteArrayList<RemoteStatusAListener>();
	private List<RemoteStatusBListener> listenerRemoteStatusB = new CopyOnWriteArrayList<RemoteStatusBListener>();
	private List<RemoteStatusCListener> listenerRemoteStatusC = new CopyOnWriteArrayList<RemoteStatusCListener>();

	public class RemoteConfiguration {
		public int remoteType;
		public int minimumRepeats;
		public boolean callbackEnabled;

		public String toString() {
			return "[" + "remoteType = " + remoteType + ", " + "minimumRepeats = " + minimumRepeats + ", " + "callbackEnabled = " + callbackEnabled + "]";
		}
	}

	public class RemoteStatusA {
		public int houseCode;
		public int receiverCode;
		public int switchTo;
		public int repeats;

		public String toString() {
			return "[" + "houseCode = " + houseCode + ", " + "receiverCode = " + receiverCode + ", " + "switchTo = " + switchTo + ", " + "repeats = " + repeats + "]";
		}
	}

	public class RemoteStatusB {
		public long address;
		public int unit;
		public int switchTo;
		public int dimValue;
		public int repeats;

		public String toString() {
			return "[" + "address = " + address + ", " + "unit = " + unit + ", " + "switchTo = " + switchTo + ", " + "dimValue = " + dimValue + ", " + "repeats = " + repeats + "]";
		}
	}

	public class RemoteStatusC {
		public char systemCode;
		public int deviceCode;
		public int switchTo;
		public int repeats;

		public String toString() {
			return "[" + "systemCode = " + systemCode + ", " + "deviceCode = " + deviceCode + ", " + "switchTo = " + switchTo + ", " + "repeats = " + repeats + "]";
		}
	}

	public class SPITFPErrorCount {
		public long errorCountAckChecksum;
		public long errorCountMessageChecksum;
		public long errorCountFrame;
		public long errorCountOverflow;

		public String toString() {
			return "[" + "errorCountAckChecksum = " + errorCountAckChecksum + ", " + "errorCountMessageChecksum = " + errorCountMessageChecksum + ", " + "errorCountFrame = " + errorCountFrame + ", " + "errorCountOverflow = " + errorCountOverflow + "]";
		}
	}

	/**
	 * This listener is triggered whenever the switching state changes
	 * from busy to ready, see {@link BrickletRemoteSwitchV2#getSwitchingState()}.
	 */
	public interface SwitchingDoneListener extends DeviceListener {
		public void switchingDone();
	}

	/**
	 * Returns the house code, receiver code, switch state (on/off) and number of repeats for
	 * remote type A.
	 * 
	 * The repeats are the number of received identical data packets. The longer the button is pressed,
	 * the higher the repeat number. The listener is triggered with every repeat.
	 * 
	 * You have to enable the listener with {@link BrickletRemoteSwitchV2#setRemoteConfiguration(int, int, boolean)}. The number
	 * of repeats that you can set in the configuration is the minimum number of repeats that have
	 * to be seen before the listener is triggered for the first time.
	 */
	public interface RemoteStatusAListener extends DeviceListener {
		public void remoteStatusA(int houseCode, int receiverCode, int switchTo, int repeats);
	}

	/**
	 * Returns the address (unique per remote), unit (button number), switch state (on/off) and number of repeats for
	 * remote type B.
	 * 
	 * If the remote supports dimming the dim value is used instead of the switch state.
	 * 
	 * The repeats are the number of received identical data packets. The longer the button is pressed,
	 * the higher the repeat number. The listener is triggered with every repeat.
	 * 
	 * You have to enable the listener with {@link BrickletRemoteSwitchV2#setRemoteConfiguration(int, int, boolean)}. The number
	 * of repeats that you can set in the configuration is the minimum number of repeats that have
	 * to be seen before the listener is triggered for the first time.
	 */
	public interface RemoteStatusBListener extends DeviceListener {
		public void remoteStatusB(long address, int unit, int switchTo, int dimValue, int repeats);
	}

	/**
	 * Returns the system code, device code, switch state (on/off) and number of repeats for
	 * remote type C.
	 * 
	 * The repeats are the number of received identical data packets. The longer the button is pressed,
	 * the higher the repeat number. The listener is triggered with every repeat.
	 * 
	 * You have to enable the listener with {@link BrickletRemoteSwitchV2#setRemoteConfiguration(int, int, boolean)}. The number
	 * of repeats that you can set in the configuration is the minimum number of repeats that have
	 * to be seen before the listener is triggered for the first time.
	 */
	public interface RemoteStatusCListener extends DeviceListener {
		public void remoteStatusC(char systemCode, int deviceCode, int switchTo, int repeats);
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletRemoteSwitchV2(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 0;

		deviceIdentifier = DEVICE_IDENTIFIER;
		deviceDisplayName = DEVICE_DISPLAY_NAME;

		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_SWITCHING_STATE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_REPEATS)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_REPEATS)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SWITCH_SOCKET_A)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SWITCH_SOCKET_B)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_DIM_SOCKET_B)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SWITCH_SOCKET_C)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_REMOTE_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_REMOTE_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_REMOTE_STATUS_A)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_REMOTE_STATUS_B)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_REMOTE_STATUS_C)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_SPITFP_ERROR_COUNT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_WRITE_FIRMWARE_POINTER)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_WRITE_FIRMWARE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CHIP_TEMPERATURE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_RESET)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_WRITE_UID)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_READ_UID)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_SWITCHING_DONE] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				for (SwitchingDoneListener listener: listenerSwitchingDone) {
					listener.switchingDone();
				}
			}
		};

		callbacks[CALLBACK_REMOTE_STATUS_A] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int houseCode = IPConnection.unsignedByte(bb.get());
				int receiverCode = IPConnection.unsignedByte(bb.get());
				int switchTo = IPConnection.unsignedByte(bb.get());
				int repeats = IPConnection.unsignedShort(bb.getShort());

				for (RemoteStatusAListener listener: listenerRemoteStatusA) {
					listener.remoteStatusA(houseCode, receiverCode, switchTo, repeats);
				}
			}
		};

		callbacks[CALLBACK_REMOTE_STATUS_B] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				long address = IPConnection.unsignedInt(bb.getInt());
				int unit = IPConnection.unsignedByte(bb.get());
				int switchTo = IPConnection.unsignedByte(bb.get());
				int dimValue = IPConnection.unsignedByte(bb.get());
				int repeats = IPConnection.unsignedShort(bb.getShort());

				for (RemoteStatusBListener listener: listenerRemoteStatusB) {
					listener.remoteStatusB(address, unit, switchTo, dimValue, repeats);
				}
			}
		};

		callbacks[CALLBACK_REMOTE_STATUS_C] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				char systemCode = (char)(bb.get());
				int deviceCode = IPConnection.unsignedByte(bb.get());
				int switchTo = IPConnection.unsignedByte(bb.get());
				int repeats = IPConnection.unsignedShort(bb.getShort());

				for (RemoteStatusCListener listener: listenerRemoteStatusC) {
					listener.remoteStatusC(systemCode, deviceCode, switchTo, repeats);
				}
			}
		};

		ipcon.addDevice(this);
	}

	/**
	 * Returns the current switching state. If the current state is busy, the
	 * Bricklet is currently sending a code to switch a socket. It will not
	 * accept any calls of switch socket functions until the state changes to ready.
	 * 
	 * How long the switching takes is dependent on the number of repeats, see
	 * {@link BrickletRemoteSwitchV2#setRepeats(int)}.
	 */
	public int getSwitchingState() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_SWITCHING_STATE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int state = IPConnection.unsignedByte(bb.get());

		return state;
	}

	/**
	 * Sets the number of times the code is sent when one of the Switch Socket
	 * functions is called. The repeats basically correspond to the amount of time
	 * that a button of the remote is pressed.
	 * 
	 * Some dimmers are controlled by the length of a button pressed,
	 * this can be simulated by increasing the repeats.
	 */
	public void setRepeats(int repeats) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_REPEATS, this);

		bb.put((byte)repeats);

		sendRequest(bb.array());
	}

	/**
	 * Returns the number of repeats as set by {@link BrickletRemoteSwitchV2#setRepeats(int)}.
	 */
	public int getRepeats() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_REPEATS, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int repeats = IPConnection.unsignedByte(bb.get());

		return repeats;
	}

	/**
	 * To switch a type A socket you have to give the house code, receiver code and the
	 * state (on or off) you want to switch to.
	 * 
	 * A detailed description on how you can figure out the house and receiver code
	 * can be found :ref:`here &lt;remote_switch_bricklet_type_a_house_and_receiver_code&gt;`.
	 */
	public void switchSocketA(int houseCode, int receiverCode, int switchTo) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)11, FUNCTION_SWITCH_SOCKET_A, this);

		bb.put((byte)houseCode);
		bb.put((byte)receiverCode);
		bb.put((byte)switchTo);

		sendRequest(bb.array());
	}

	/**
	 * To switch a type B socket you have to give the address, unit and the state
	 * (on or off) you want to switch to.
	 * 
	 * To switch all devices with the same address use 255 for the unit.
	 * 
	 * A detailed description on how you can teach a socket the address and unit can
	 * be found :ref:`here &lt;remote_switch_bricklet_type_b_address_and_unit&gt;`.
	 */
	public void switchSocketB(long address, int unit, int switchTo) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)14, FUNCTION_SWITCH_SOCKET_B, this);

		bb.putInt((int)address);
		bb.put((byte)unit);
		bb.put((byte)switchTo);

		sendRequest(bb.array());
	}

	/**
	 * To control a type B dimmer you have to give the address, unit and the
	 * dim value you want to set the dimmer to.
	 * 
	 * A detailed description on how you can teach a dimmer the address and unit can
	 * be found :ref:`here &lt;remote_switch_bricklet_type_b_address_and_unit&gt;`.
	 */
	public void dimSocketB(long address, int unit, int dimValue) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)14, FUNCTION_DIM_SOCKET_B, this);

		bb.putInt((int)address);
		bb.put((byte)unit);
		bb.put((byte)dimValue);

		sendRequest(bb.array());
	}

	/**
	 * To switch a type C socket you have to give the system code, device code and the
	 * state (on or off) you want to switch to.
	 * 
	 * A detailed description on how you can figure out the system and device code
	 * can be found :ref:`here &lt;remote_switch_bricklet_type_c_system_and_device_code&gt;`.
	 */
	public void switchSocketC(char systemCode, int deviceCode, int switchTo) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)11, FUNCTION_SWITCH_SOCKET_C, this);

		bb.put((byte)systemCode);
		bb.put((byte)deviceCode);
		bb.put((byte)switchTo);

		sendRequest(bb.array());
	}

	/**
	 * Sets the configuration for **receiving** data from a remote of type A, B or C.
	 * 
	 * * Remote Type: A, B or C depending on the type of remote you want to receive.
	 * * Minimum Repeats: The minimum number of repeated data packets until the listener
	 *   is triggered (if enabled).
	 * * Listener Enabled: Enable or disable listener (see {@link BrickletRemoteSwitchV2.RemoteStatusAListener} listener,
	 *   {@link BrickletRemoteSwitchV2.RemoteStatusBListener} listener and {@link BrickletRemoteSwitchV2.RemoteStatusCListener} listener).
	 */
	public void setRemoteConfiguration(int remoteType, int minimumRepeats, boolean callbackEnabled) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_REMOTE_CONFIGURATION, this);

		bb.put((byte)remoteType);
		bb.putShort((short)minimumRepeats);
		bb.put((byte)(callbackEnabled ? 1 : 0));

		sendRequest(bb.array());
	}

	/**
	 * Returns the remote configuration as set by {@link BrickletRemoteSwitchV2#setRemoteConfiguration(int, int, boolean)}
	 */
	public RemoteConfiguration getRemoteConfiguration() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_REMOTE_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		RemoteConfiguration obj = new RemoteConfiguration();
		obj.remoteType = IPConnection.unsignedByte(bb.get());
		obj.minimumRepeats = IPConnection.unsignedShort(bb.getShort());
		obj.callbackEnabled = (bb.get()) != 0;

		return obj;
	}

	/**
	 * Returns the house code, receiver code, switch state (on/off) and number of
	 * repeats for remote type A.
	 * 
	 * Repeats == 0 means there was no button press. Repeats &gt;= 1 means there
	 * was a button press with the specified house/receiver code. The repeats are the
	 * number of received identical data packets. The longer the button is pressed,
	 * the higher the repeat number.
	 * 
	 * Use the listener to get this data automatically when a button is pressed,
	 * see {@link BrickletRemoteSwitchV2#setRemoteConfiguration(int, int, boolean)} and {@link BrickletRemoteSwitchV2.RemoteStatusAListener} listener.
	 */
	public RemoteStatusA getRemoteStatusA() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_REMOTE_STATUS_A, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		RemoteStatusA obj = new RemoteStatusA();
		obj.houseCode = IPConnection.unsignedByte(bb.get());
		obj.receiverCode = IPConnection.unsignedByte(bb.get());
		obj.switchTo = IPConnection.unsignedByte(bb.get());
		obj.repeats = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Returns the address (unique per remote), unit (button number), switch state
	 * (on/off) and number of repeats for remote type B.
	 * 
	 * If the remote supports dimming the dim value is used instead of the switch state.
	 * 
	 * If repeats=0 there was no button press. If repeats &gt;= 1 there
	 * was a button press with the specified address/unit. The repeats are the number of received
	 * identical data packets. The longer the button is pressed, the higher the repeat number.
	 * 
	 * Use the listener to get this data automatically when a button is pressed,
	 * see {@link BrickletRemoteSwitchV2#setRemoteConfiguration(int, int, boolean)} and {@link BrickletRemoteSwitchV2.RemoteStatusBListener} listener.
	 */
	public RemoteStatusB getRemoteStatusB() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_REMOTE_STATUS_B, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		RemoteStatusB obj = new RemoteStatusB();
		obj.address = IPConnection.unsignedInt(bb.getInt());
		obj.unit = IPConnection.unsignedByte(bb.get());
		obj.switchTo = IPConnection.unsignedByte(bb.get());
		obj.dimValue = IPConnection.unsignedByte(bb.get());
		obj.repeats = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Returns the system code, device code, switch state (on/off) and number of repeats for
	 * remote type C.
	 * 
	 * If repeats=0 there was no button press. If repeats &gt;= 1 there
	 * was a button press with the specified system/device code. The repeats are the number of received
	 * identical data packets. The longer the button is pressed, the higher the repeat number.
	 * 
	 * Use the listener to get this data automatically when a button is pressed,
	 * see {@link BrickletRemoteSwitchV2#setRemoteConfiguration(int, int, boolean)} and {@link BrickletRemoteSwitchV2.RemoteStatusCListener} listener.
	 */
	public RemoteStatusC getRemoteStatusC() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_REMOTE_STATUS_C, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		RemoteStatusC obj = new RemoteStatusC();
		obj.systemCode = (char)(bb.get());
		obj.deviceCode = IPConnection.unsignedByte(bb.get());
		obj.switchTo = IPConnection.unsignedByte(bb.get());
		obj.repeats = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Returns the error count for the communication between Brick and Bricklet.
	 * 
	 * The errors are divided into
	 * 
	 * * ACK checksum errors,
	 * * message checksum errors,
	 * * framing errors and
	 * * overflow errors.
	 * 
	 * The errors counts are for errors that occur on the Bricklet side. All
	 * Bricks have a similar function that returns the errors on the Brick side.
	 */
	public SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_SPITFP_ERROR_COUNT, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		SPITFPErrorCount obj = new SPITFPErrorCount();
		obj.errorCountAckChecksum = IPConnection.unsignedInt(bb.getInt());
		obj.errorCountMessageChecksum = IPConnection.unsignedInt(bb.getInt());
		obj.errorCountFrame = IPConnection.unsignedInt(bb.getInt());
		obj.errorCountOverflow = IPConnection.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Sets the bootloader mode and returns the status after the requested
	 * mode change was instigated.
	 * 
	 * You can change from bootloader mode to firmware mode and vice versa. A change
	 * from bootloader mode to firmware mode will only take place if the entry function,
	 * device identifier and CRC are present and correct.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int setBootloaderMode(int mode) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_BOOTLOADER_MODE, this);

		bb.put((byte)mode);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnection.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Returns the current bootloader mode, see {@link BrickletRemoteSwitchV2#setBootloaderMode(int)}.
	 */
	public int getBootloaderMode() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_BOOTLOADER_MODE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int mode = IPConnection.unsignedByte(bb.get());

		return mode;
	}

	/**
	 * Sets the firmware pointer for {@link BrickletRemoteSwitchV2#writeFirmware(int[])}. The pointer has
	 * to be increased by chunks of size 64. The data is written to flash
	 * every 4 chunks (which equals to one page of size 256).
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_WRITE_FIRMWARE_POINTER, this);

		bb.putInt((int)pointer);

		sendRequest(bb.array());
	}

	/**
	 * Writes 64 Bytes of firmware at the position as written by
	 * {@link BrickletRemoteSwitchV2#setWriteFirmwarePointer(long)} before. The firmware is written
	 * to flash every 4 chunks.
	 * 
	 * You can only write firmware in bootloader mode.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int writeFirmware(int[] data) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)72, FUNCTION_WRITE_FIRMWARE, this);

		for (int i = 0; i < 64; i++) {
			bb.put((byte)data[i]);
		}

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnection.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Sets the status LED configuration. By default the LED shows
	 * communication traffic between Brick and Bricklet, it flickers once
	 * for every 10 received data packets.
	 * 
	 * You can also turn the LED permanently on/off or show a heartbeat.
	 * 
	 * If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
	 */
	public void setStatusLEDConfig(int config) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_STATUS_LED_CONFIG, this);

		bb.put((byte)config);

		sendRequest(bb.array());
	}

	/**
	 * Returns the configuration as set by {@link BrickletRemoteSwitchV2#setStatusLEDConfig(int)}
	 */
	public int getStatusLEDConfig() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_STATUS_LED_CONFIG, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int config = IPConnection.unsignedByte(bb.get());

		return config;
	}

	/**
	 * Returns the temperature as measured inside the microcontroller. The
	 * value returned is not the ambient temperature!
	 * 
	 * The temperature is only proportional to the real temperature and it has bad
	 * accuracy. Practically it is only useful as an indicator for
	 * temperature changes.
	 */
	public int getChipTemperature() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CHIP_TEMPERATURE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int temperature = (bb.getShort());

		return temperature;
	}

	/**
	 * Calling this function will reset the Bricklet. All configurations
	 * will be lost.
	 * 
	 * After a reset you have to create new device objects,
	 * calling functions on the existing ones will result in
	 * undefined behavior!
	 */
	public void reset() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_RESET, this);


		sendRequest(bb.array());
	}

	/**
	 * Writes a new UID into flash. If you want to set a new UID
	 * you have to decode the Base58 encoded UID string into an
	 * integer first.
	 * 
	 * We recommend that you use Brick Viewer to change the UID.
	 */
	public void writeUID(long uid) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_WRITE_UID, this);

		bb.putInt((int)uid);

		sendRequest(bb.array());
	}

	/**
	 * Returns the current UID as an integer. Encode as
	 * Base58 to get the usual string version.
	 */
	public long readUID() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_READ_UID, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long uid = IPConnection.unsignedInt(bb.getInt());

		return uid;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
	 * The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
	 * connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always as
	 * position 'z'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnection.string(bb, 8);
		obj.connectedUid = IPConnection.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Adds a SwitchingDone listener.
	 */
	public void addSwitchingDoneListener(SwitchingDoneListener listener) {
		listenerSwitchingDone.add(listener);
	}

	/**
	 * Removes a SwitchingDone listener.
	 */
	public void removeSwitchingDoneListener(SwitchingDoneListener listener) {
		listenerSwitchingDone.remove(listener);
	}

	/**
	 * Adds a RemoteStatusA listener.
	 */
	public void addRemoteStatusAListener(RemoteStatusAListener listener) {
		listenerRemoteStatusA.add(listener);
	}

	/**
	 * Removes a RemoteStatusA listener.
	 */
	public void removeRemoteStatusAListener(RemoteStatusAListener listener) {
		listenerRemoteStatusA.remove(listener);
	}

	/**
	 * Adds a RemoteStatusB listener.
	 */
	public void addRemoteStatusBListener(RemoteStatusBListener listener) {
		listenerRemoteStatusB.add(listener);
	}

	/**
	 * Removes a RemoteStatusB listener.
	 */
	public void removeRemoteStatusBListener(RemoteStatusBListener listener) {
		listenerRemoteStatusB.remove(listener);
	}

	/**
	 * Adds a RemoteStatusC listener.
	 */
	public void addRemoteStatusCListener(RemoteStatusCListener listener) {
		listenerRemoteStatusC.add(listener);
	}

	/**
	 * Removes a RemoteStatusC listener.
	 */
	public void removeRemoteStatusCListener(RemoteStatusCListener listener) {
		listenerRemoteStatusC.remove(listener);
	}

    private final Logger logger = LoggerFactory.getLogger(BrickletRemoteSwitchV2.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletRemoteSwitchV2.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletRemoteSwitchV2Config cfg = (BrickletRemoteSwitchV2Config) config.as(BrickletRemoteSwitchV2Config.class);
        this.addSwitchingDoneListener(() -> {if(true) {triggerChannelFn.accept("BrickletRemoteSwitchV2SwitchingDone", transformBrickletRemoteSwitchV2SwitchingDoneCallback0(cfg));}});
		this.addRemoteStatusAListener((houseCode, receiverCode, switchTo, repeats) -> {if(true) {triggerChannelFn.accept("BrickletRemoteSwitchV2RemoteStatusAAvailable", transformBrickletRemoteSwitchV2RemoteStatusAAvailableCallback0(houseCode, receiverCode, switchTo, repeats, cfg));}});
		this.addRemoteStatusBListener((address, unit, switchTo, dimValue, repeats) -> {if(true) {triggerChannelFn.accept("BrickletRemoteSwitchV2RemoteStatusBAvailable", transformBrickletRemoteSwitchV2RemoteStatusBAvailableCallback0(address, unit, switchTo, dimValue, repeats, cfg));}});
		this.addRemoteStatusCListener((systemCode, deviceCode, switchTo, repeats) -> {if(true) {triggerChannelFn.accept("BrickletRemoteSwitchV2RemoteStatusCAvailable", transformBrickletRemoteSwitchV2RemoteStatusCAvailableCallback0(systemCode, deviceCode, switchTo, repeats, cfg));}});
        this.setRemoteConfiguration(cfg.remoteType, cfg.minimumRepeats, true);
		this.setStatusLEDConfig(cfg.statusLEDConfig);
		{
		
		}
		{
		
		}
		{
		
		}
		{
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        BrickletRemoteSwitchV2Config cfg = (BrickletRemoteSwitchV2Config) config.as(BrickletRemoteSwitchV2Config.class);
        this.listenerSwitchingDone.clear();
		this.listenerRemoteStatusA.clear();
		this.listenerRemoteStatusB.clear();
		this.listenerRemoteStatusC.clear();
        
		
		
		
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletRemoteSwitchV2Config cfg = (BrickletRemoteSwitchV2Config) config.as(BrickletRemoteSwitchV2Config.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletRemoteSwitchV2SwitchingDone");
		result.add("BrickletRemoteSwitchV2RemoteStatusAAvailable");
		result.add("BrickletRemoteSwitchV2RemoteStatusBAvailable");
		result.add("BrickletRemoteSwitchV2RemoteStatusCAvailable");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Remote Switch Bricklet 2.0").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Controls remote mains switches and receives signals from remotes").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletRemoteSwitchV2SwitchingDone", new ChannelTypeUID("system", "trigger")).withLabel("Switching Done").withDescription("This channel is triggered whenever the switching state changes from busy to ready.").build(), new ChannelDefinitionBuilder("BrickletRemoteSwitchV2RemoteStatusAAvailable", new ChannelTypeUID("system", "trigger")).withLabel("Remote Status A Available").withDescription("This channel is triggered if at least the configured minimum of repeats of identical data packets for remote type A were received. You can get the house and receiver code, switch state and repeats with the getRemoteStatusA action.").build(), new ChannelDefinitionBuilder("BrickletRemoteSwitchV2RemoteStatusBAvailable", new ChannelTypeUID("system", "trigger")).withLabel("Remote Status B Available").withDescription("This channel is triggered if at least the configured minimum of repeats of identical data packets for remote type B were received. You can get the house and receiver code, switch state and repeats with the getRemoteStatusB action.").build(), new ChannelDefinitionBuilder("BrickletRemoteSwitchV2RemoteStatusCAvailable", new ChannelTypeUID("system", "trigger")).withLabel("Remote Status C Available").withDescription("This channel is triggered if at least the configured minimum of repeats of identical data packets for remote type C were received. You can get the house and receiver code, switch state and repeats with the getRemoteStatusC action.").build())).withProperties(props).buildBridge();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletremoteswitchv2":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("remoteType", Type.INTEGER).withDefault("0").withDescription("Type A, B or C depending on the type of remote you want to receive.").withLabel("Remote Type").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("0", "A"), new ParameterOption("1", "B"), new ParameterOption("2", "C"))).build(), ConfigDescriptionParameterBuilder.create("minimumRepeats", Type.INTEGER).withDefault("2").withDescription("The minimum number of repeated data packets until the Remote Status channels trigger.").withLabel("Minimum Repeats").build(), ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.INTEGER).withDefault("3").withDescription("The status LED configuration. By default the LED shows communication traffic between Brick and Bricklet, it flickers once for every 10 received data packets.<br/><br/>You can also turn the LED permanently on/off or show a heartbeat.<br/><br/>If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.").withLabel("Status LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Status"))).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletRemoteSwitchV2Config cfg = (BrickletRemoteSwitchV2Config) config.as(BrickletRemoteSwitchV2Config.class);
        switch(channel) {
            case "BrickletRemoteSwitchV2SwitchingDone":
               return;
            case "BrickletRemoteSwitchV2RemoteStatusAAvailable":
               return;
            case "BrickletRemoteSwitchV2RemoteStatusBAvailable":
               return;
            case "BrickletRemoteSwitchV2RemoteStatusCAvailable":
               return;
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletRemoteSwitchV2Config cfg = (BrickletRemoteSwitchV2Config) config.as(BrickletRemoteSwitchV2Config.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private String transformBrickletRemoteSwitchV2SwitchingDoneCallback0(BrickletRemoteSwitchV2Config cfg) {
        return "";
    }
	    private String transformBrickletRemoteSwitchV2RemoteStatusAAvailableCallback0(int houseCode, int receiverCode, int switchTo, int repeats, BrickletRemoteSwitchV2Config cfg) {
        return "";
    }
	    private String transformBrickletRemoteSwitchV2RemoteStatusBAvailableCallback0(long address, int unit, int switchTo, int dimValue, int repeats, BrickletRemoteSwitchV2Config cfg) {
        return "";
    }
	    private String transformBrickletRemoteSwitchV2RemoteStatusCAvailableCallback0(char systemCode, int deviceCode, int switchTo, int repeats, BrickletRemoteSwitchV2Config cfg) {
        return "";
    }
}
