/* ***********************************************************
 * This file was automatically generated on 2020-01-31.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;
import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.library.types.RawType;
import org.eclipse.smarthome.core.library.types.OnOffType;

/**
 * 80x60 pixel thermal imaging camera
 */
public class BrickletThermalImaging extends Device {
	public final static int DEVICE_IDENTIFIER = 278;
	public final static String DEVICE_DISPLAY_NAME = "Thermal Imaging Bricklet";

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(DEVICE_DISPLAY_NAME, "brickletthermalimaging", DEVICE_IDENTIFIER, BrickletThermalImaging.class, BrickletThermalImagingActions.class, "2.0.0");

	public final static byte FUNCTION_GET_HIGH_CONTRAST_IMAGE_LOW_LEVEL = (byte)1;
	public final static byte FUNCTION_GET_TEMPERATURE_IMAGE_LOW_LEVEL = (byte)2;
	public final static byte FUNCTION_GET_STATISTICS = (byte)3;
	public final static byte FUNCTION_SET_RESOLUTION = (byte)4;
	public final static byte FUNCTION_GET_RESOLUTION = (byte)5;
	public final static byte FUNCTION_SET_SPOTMETER_CONFIG = (byte)6;
	public final static byte FUNCTION_GET_SPOTMETER_CONFIG = (byte)7;
	public final static byte FUNCTION_SET_HIGH_CONTRAST_CONFIG = (byte)8;
	public final static byte FUNCTION_GET_HIGH_CONTRAST_CONFIG = (byte)9;
	public final static byte FUNCTION_SET_IMAGE_TRANSFER_CONFIG = (byte)10;
	public final static byte FUNCTION_GET_IMAGE_TRANSFER_CONFIG = (byte)11;
	public final static byte FUNCTION_GET_SPITFP_ERROR_COUNT = (byte)234;
	public final static byte FUNCTION_SET_BOOTLOADER_MODE = (byte)235;
	public final static byte FUNCTION_GET_BOOTLOADER_MODE = (byte)236;
	public final static byte FUNCTION_SET_WRITE_FIRMWARE_POINTER = (byte)237;
	public final static byte FUNCTION_WRITE_FIRMWARE = (byte)238;
	public final static byte FUNCTION_SET_STATUS_LED_CONFIG = (byte)239;
	public final static byte FUNCTION_GET_STATUS_LED_CONFIG = (byte)240;
	public final static byte FUNCTION_GET_CHIP_TEMPERATURE = (byte)242;
	public final static byte FUNCTION_RESET = (byte)243;
	public final static byte FUNCTION_WRITE_UID = (byte)248;
	public final static byte FUNCTION_READ_UID = (byte)249;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_HIGH_CONTRAST_IMAGE_LOW_LEVEL = 12;
	private final static int CALLBACK_TEMPERATURE_IMAGE_LOW_LEVEL = 13;
	private final static int CALLBACK_HIGH_CONTRAST_IMAGE = -12;
	private final static int CALLBACK_TEMPERATURE_IMAGE = -13;

	public final static int RESOLUTION_0_TO_6553_KELVIN = 0;
	public final static int RESOLUTION_0_TO_655_KELVIN = 1;
	public final static int FFC_STATUS_NEVER_COMMANDED = 0;
	public final static int FFC_STATUS_IMMINENT = 1;
	public final static int FFC_STATUS_IN_PROGRESS = 2;
	public final static int FFC_STATUS_COMPLETE = 3;
	public final static int IMAGE_TRANSFER_MANUAL_HIGH_CONTRAST_IMAGE = 0;
	public final static int IMAGE_TRANSFER_MANUAL_TEMPERATURE_IMAGE = 1;
	public final static int IMAGE_TRANSFER_CALLBACK_HIGH_CONTRAST_IMAGE = 2;
	public final static int IMAGE_TRANSFER_CALLBACK_TEMPERATURE_IMAGE = 3;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;

	private List<HighContrastImageLowLevelListener> listenerHighContrastImageLowLevel = new CopyOnWriteArrayList<HighContrastImageLowLevelListener>();
	private List<TemperatureImageLowLevelListener> listenerTemperatureImageLowLevel = new CopyOnWriteArrayList<TemperatureImageLowLevelListener>();
	private List<HighContrastImageListener> listenerHighContrastImage = new CopyOnWriteArrayList<HighContrastImageListener>();
	private List<TemperatureImageListener> listenerTemperatureImage = new CopyOnWriteArrayList<TemperatureImageListener>();

	public class HighContrastImageLowLevel {
		public int imageChunkOffset;
		public int[] imageChunkData = new int[62];

		public String toString() {
			return "[" + "imageChunkOffset = " + imageChunkOffset + ", " + "imageChunkData = " + Arrays.toString(imageChunkData) + "]";
		}
	}

	public class TemperatureImageLowLevel {
		public int imageChunkOffset;
		public int[] imageChunkData = new int[31];

		public String toString() {
			return "[" + "imageChunkOffset = " + imageChunkOffset + ", " + "imageChunkData = " + Arrays.toString(imageChunkData) + "]";
		}
	}

	public class Statistics {
		public int[] spotmeterStatistics = new int[4];
		public int[] temperatures = new int[4];
		public int resolution;
		public int ffcStatus;
		public boolean[] temperatureWarning = new boolean[2];

		public String toString() {
			return "[" + "spotmeterStatistics = " + Arrays.toString(spotmeterStatistics) + ", " + "temperatures = " + Arrays.toString(temperatures) + ", " + "resolution = " + resolution + ", " + "ffcStatus = " + ffcStatus + ", " + "temperatureWarning = " + Arrays.toString(temperatureWarning) + "]";
		}
	}

	public class HighContrastConfig {
		public int[] regionOfInterest = new int[4];
		public int dampeningFactor;
		public int[] clipLimit = new int[2];
		public int emptyCounts;

		public String toString() {
			return "[" + "regionOfInterest = " + Arrays.toString(regionOfInterest) + ", " + "dampeningFactor = " + dampeningFactor + ", " + "clipLimit = " + Arrays.toString(clipLimit) + ", " + "emptyCounts = " + emptyCounts + "]";
		}
	}

	public class SPITFPErrorCount {
		public long errorCountAckChecksum;
		public long errorCountMessageChecksum;
		public long errorCountFrame;
		public long errorCountOverflow;

		public String toString() {
			return "[" + "errorCountAckChecksum = " + errorCountAckChecksum + ", " + "errorCountMessageChecksum = " + errorCountMessageChecksum + ", " + "errorCountFrame = " + errorCountFrame + ", " + "errorCountOverflow = " + errorCountOverflow + "]";
		}
	}

	/**
	 * @see HighContrastImageListener
	 */
	public interface HighContrastImageLowLevelListener extends DeviceListener {
		public void highContrastImageLowLevel(int imageChunkOffset, int[] imageChunkData);
	}

	/**
	 * @see TemperatureImageListener
	 */
	public interface TemperatureImageLowLevelListener extends DeviceListener {
		public void temperatureImageLowLevel(int imageChunkOffset, int[] imageChunkData);
	}

	/**
	 * This listener is triggered with every new high contrast image if the transfer image
	 * config is configured for high contrast listener (see {@link BrickletThermalImaging#setImageTransferConfig(int)}).
	 * 
	 * The data is organized as a 8-bit value 80x60 pixel matrix linearized in
	 * a one-dimensional array. The data is arranged line by line from top left to
	 * bottom right.
	 * 
	 * Each 8-bit value represents one gray-scale image pixel that can directly be
	 * shown to a user on a display.
	 * 
	 * \note
	 *  If reconstructing the value fails, the listener is triggered with null for Image.
	 */
	public interface HighContrastImageListener extends DeviceListener {
		public void highContrastImage(int[] image);
	}

	/**
	 * This listener is triggered with every new temperature image if the transfer image
	 * config is configured for temperature listener (see {@link BrickletThermalImaging#setImageTransferConfig(int)}).
	 * 
	 * The data is organized as a 16-bit value 80x60 pixel matrix linearized in
	 * a one-dimensional array. The data is arranged line by line from top left to
	 * bottom right.
	 * 
	 * Each 16-bit value represents one temperature measurement in either
	 * Kelvin/10 or Kelvin/100 (depending on the resolution set with {@link BrickletThermalImaging#setResolution(int)}).
	 * 
	 * \note
	 *  If reconstructing the value fails, the listener is triggered with null for Image.
	 */
	public interface TemperatureImageListener extends DeviceListener {
		public void temperatureImage(int[] image);
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletThermalImaging(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 0;

		deviceIdentifier = DEVICE_IDENTIFIER;
		deviceDisplayName = DEVICE_DISPLAY_NAME;

		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_HIGH_CONTRAST_IMAGE_LOW_LEVEL)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_TEMPERATURE_IMAGE_LOW_LEVEL)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_STATISTICS)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_RESOLUTION)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_RESOLUTION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_SPOTMETER_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_SPOTMETER_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_HIGH_CONTRAST_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_HIGH_CONTRAST_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_IMAGE_TRANSFER_CONFIG)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_IMAGE_TRANSFER_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_SPITFP_ERROR_COUNT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_WRITE_FIRMWARE_POINTER)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_WRITE_FIRMWARE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CHIP_TEMPERATURE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_RESET)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_WRITE_UID)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_READ_UID)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		highLevelCallbacks[-CALLBACK_HIGH_CONTRAST_IMAGE] = new IPConnection.DeviceHighLevelCallback();
		callbacks[CALLBACK_HIGH_CONTRAST_IMAGE_LOW_LEVEL] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int imageChunkOffset = IPConnection.unsignedShort(bb.getShort());
				int[] imageChunkData = new int[62];
				for (int i = 0; i < 62; i++) {
					imageChunkData[i] = IPConnection.unsignedByte(bb.get());
				}

				IPConnection.DeviceHighLevelCallback highLevelCallback = highLevelCallbacks[-CALLBACK_HIGH_CONTRAST_IMAGE];
				int imageChunkLength = Math.min(4800 - imageChunkOffset, 62);

				if (highLevelCallback.data == null) { // no stream in-progress
					if (imageChunkOffset == 0) { // stream starts
						highLevelCallback.data = new int[4800];
						highLevelCallback.length = imageChunkLength;

						System.arraycopy(imageChunkData, 0, (int[])highLevelCallback.data, 0, imageChunkLength);

						if (highLevelCallback.length >= 4800) { // stream complete
							for (HighContrastImageListener listener: listenerHighContrastImage) {
								listener.highContrastImage((int[])highLevelCallback.data);
							}

							highLevelCallback.data = null;
							highLevelCallback.length = 0;
						}
					} else { // ignore tail of current stream, wait for next stream start
					}
				} else { // stream in-progress
					if (imageChunkOffset != highLevelCallback.length) { // stream out-of-sync
						highLevelCallback.data = null;
						highLevelCallback.length = 0;

						for (HighContrastImageListener listener: listenerHighContrastImage) {
							listener.highContrastImage((int[])highLevelCallback.data);
						}
					} else { // stream in-sync
						System.arraycopy(imageChunkData, 0, (int[])highLevelCallback.data, highLevelCallback.length, imageChunkLength);
						highLevelCallback.length += imageChunkLength;

						if (highLevelCallback.length >= 4800) { // stream complete
							for (HighContrastImageListener listener: listenerHighContrastImage) {
								listener.highContrastImage((int[])highLevelCallback.data);
							}

							highLevelCallback.data = null;
							highLevelCallback.length = 0;
						}
					}
				}

				for (HighContrastImageLowLevelListener listener: listenerHighContrastImageLowLevel) {
					listener.highContrastImageLowLevel(imageChunkOffset, imageChunkData);
				}
			}
		};

		highLevelCallbacks[-CALLBACK_TEMPERATURE_IMAGE] = new IPConnection.DeviceHighLevelCallback();
		callbacks[CALLBACK_TEMPERATURE_IMAGE_LOW_LEVEL] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int imageChunkOffset = IPConnection.unsignedShort(bb.getShort());
				int[] imageChunkData = new int[31];
				for (int i = 0; i < 31; i++) {
					imageChunkData[i] = IPConnection.unsignedShort(bb.getShort());
				}

				IPConnection.DeviceHighLevelCallback highLevelCallback = highLevelCallbacks[-CALLBACK_TEMPERATURE_IMAGE];
				int imageChunkLength = Math.min(4800 - imageChunkOffset, 31);

				if (highLevelCallback.data == null) { // no stream in-progress
					if (imageChunkOffset == 0) { // stream starts
						highLevelCallback.data = new int[4800];
						highLevelCallback.length = imageChunkLength;

						System.arraycopy(imageChunkData, 0, (int[])highLevelCallback.data, 0, imageChunkLength);

						if (highLevelCallback.length >= 4800) { // stream complete
							for (TemperatureImageListener listener: listenerTemperatureImage) {
								listener.temperatureImage((int[])highLevelCallback.data);
							}

							highLevelCallback.data = null;
							highLevelCallback.length = 0;
						}
					} else { // ignore tail of current stream, wait for next stream start
					}
				} else { // stream in-progress
					if (imageChunkOffset != highLevelCallback.length) { // stream out-of-sync
						highLevelCallback.data = null;
						highLevelCallback.length = 0;

						for (TemperatureImageListener listener: listenerTemperatureImage) {
							listener.temperatureImage((int[])highLevelCallback.data);
						}
					} else { // stream in-sync
						System.arraycopy(imageChunkData, 0, (int[])highLevelCallback.data, highLevelCallback.length, imageChunkLength);
						highLevelCallback.length += imageChunkLength;

						if (highLevelCallback.length >= 4800) { // stream complete
							for (TemperatureImageListener listener: listenerTemperatureImage) {
								listener.temperatureImage((int[])highLevelCallback.data);
							}

							highLevelCallback.data = null;
							highLevelCallback.length = 0;
						}
					}
				}

				for (TemperatureImageLowLevelListener listener: listenerTemperatureImageLowLevel) {
					listener.temperatureImageLowLevel(imageChunkOffset, imageChunkData);
				}
			}
		};

		ipcon.addDevice(this);
	}

	/**
	 * Returns the current high contrast image. See `here &lt;https://www.tinkerforge.com/en/doc/Hardware/Bricklets/Thermal_Imaging.html#high-contrast-image-vs-temperature-image&gt;`__
	 * for the difference between
	 * High Contrast and Temperature Image. If you don't know what to use
	 * the High Contrast Image is probably right for you.
	 * 
	 * The data is organized as a 8-bit value 80x60 pixel matrix linearized in
	 * a one-dimensional array. The data is arranged line by line from top left to
	 * bottom right.
	 * 
	 * Each 8-bit value represents one gray-scale image pixel that can directly be
	 * shown to a user on a display.
	 * 
	 * Before you can use this function you have to enable it with
	 * {@link BrickletThermalImaging#setImageTransferConfig(int)}.
	 */
	public HighContrastImageLowLevel getHighContrastImageLowLevel() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_HIGH_CONTRAST_IMAGE_LOW_LEVEL, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		HighContrastImageLowLevel obj = new HighContrastImageLowLevel();
		obj.imageChunkOffset = IPConnection.unsignedShort(bb.getShort());
		for (int i = 0; i < 62; i++) {
			obj.imageChunkData[i] = IPConnection.unsignedByte(bb.get());
		}

		return obj;
	}

	/**
	 * Returns the current temperature image. See `here &lt;https://www.tinkerforge.com/en/doc/Hardware/Bricklets/Thermal_Imaging.html#high-contrast-image-vs-temperature-image&gt;`__
	 * for the difference between High Contrast and Temperature Image.
	 * If you don't know what to use the High Contrast Image is probably right for you.
	 * 
	 * The data is organized as a 16-bit value 80x60 pixel matrix linearized in
	 * a one-dimensional array. The data is arranged line by line from top left to
	 * bottom right.
	 * 
	 * Each 16-bit value represents one temperature measurement in either
	 * Kelvin/10 or Kelvin/100 (depending on the resolution set with {@link BrickletThermalImaging#setResolution(int)}).
	 * 
	 * Before you can use this function you have to enable it with
	 * {@link BrickletThermalImaging#setImageTransferConfig(int)}.
	 */
	public TemperatureImageLowLevel getTemperatureImageLowLevel() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_TEMPERATURE_IMAGE_LOW_LEVEL, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		TemperatureImageLowLevel obj = new TemperatureImageLowLevel();
		obj.imageChunkOffset = IPConnection.unsignedShort(bb.getShort());
		for (int i = 0; i < 31; i++) {
			obj.imageChunkData[i] = IPConnection.unsignedShort(bb.getShort());
		}

		return obj;
	}

	/**
	 * Returns the spotmeter statistics, various temperatures, current resolution and status bits.
	 * 
	 * The spotmeter statistics are:
	 * 
	 * * Index 0: Mean Temperature.
	 * * Index 1: Maximum Temperature.
	 * * Index 2: Minimum Temperature.
	 * * Index 3: Pixel Count of spotmeter region of interest.
	 * 
	 * The temperatures are:
	 * 
	 * * Index 0: Focal Plain Array temperature.
	 * * Index 1: Focal Plain Array temperature at last FFC (Flat Field Correction).
	 * * Index 2: Housing temperature.
	 * * Index 3: Housing temperature at last FFC.
	 * 
	 * The resolution is either `0 to 6553 Kelvin` or `0 to 655 Kelvin`. If the resolution is the former,
	 * the temperatures are in Kelvin/10, if it is the latter the temperatures are in Kelvin/100.
	 * 
	 * FFC (Flat Field Correction) Status:
	 * 
	 * * FFC Never Commanded: Only seen on startup before first FFC.
	 * * FFC Imminent: This state is entered 2 seconds prior to initiating FFC.
	 * * FFC In Progress: Flat field correction is started (shutter moves in front of lens and back). Takes about 1 second.
	 * * FFC Complete: Shutter is in waiting position again, FFC done.
	 * 
	 * Temperature warning bits:
	 * 
	 * * Index 0: Shutter lockout (if true shutter is locked out because temperature is outside -10°C to +65°C)
	 * * Index 1: Overtemperature shut down imminent (goes true 10 seconds before shutdown)
	 */
	public Statistics getStatistics() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_STATISTICS, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Statistics obj = new Statistics();
		for (int i = 0; i < 4; i++) {
			obj.spotmeterStatistics[i] = IPConnection.unsignedShort(bb.getShort());
		}
		for (int i = 0; i < 4; i++) {
			obj.temperatures[i] = IPConnection.unsignedShort(bb.getShort());
		}
		obj.resolution = IPConnection.unsignedByte(bb.get());
		obj.ffcStatus = IPConnection.unsignedByte(bb.get());
		byte[] temperatureWarningBits = new byte[1];
		bb.get(temperatureWarningBits);
		for (int i = 0; i < 2; i++) {
			obj.temperatureWarning[i] = (temperatureWarningBits[i / 8] & (1 << (i % 8))) != 0;
		}


		return obj;
	}

	/**
	 * Sets the resolution. The Thermal Imaging Bricklet can either measure
	 * 
	 * * from 0 to 6553 Kelvin (-273.15°C to +6279.85°C) with 0.1°C resolution or
	 * * from 0 to 655 Kelvin (-273.15°C to +381.85°C) with 0.01°C resolution.
	 * 
	 * The accuracy is specified for -10°C to 450°C in the
	 * first range and -10°C and 140°C in the second range.
	 */
	public void setResolution(int resolution) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_RESOLUTION, this);

		bb.put((byte)resolution);

		sendRequest(bb.array());
	}

	/**
	 * Returns the resolution as set by {@link BrickletThermalImaging#setResolution(int)}.
	 */
	public int getResolution() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_RESOLUTION, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int resolution = IPConnection.unsignedByte(bb.get());

		return resolution;
	}

	/**
	 * Sets the spotmeter region of interest. The 4 values are
	 * 
	 * * Index 0: Column start (has to be smaller then Column end).
	 * * Index 1: Row start (has to be smaller then Row end).
	 * * Index 2: Column end (has to be smaller then 80).
	 * * Index 3: Row end (has to be smaller then 60).
	 * 
	 * The spotmeter statistics can be read out with {@link BrickletThermalImaging#getStatistics()}.
	 */
	public void setSpotmeterConfig(int[] regionOfInterest) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_SPOTMETER_CONFIG, this);

		for (int i = 0; i < 4; i++) {
			bb.put((byte)regionOfInterest[i]);
		}

		sendRequest(bb.array());
	}

	/**
	 * Returns the spotmeter config as set by {@link BrickletThermalImaging#setSpotmeterConfig(int[])}.
	 */
	public int[] getSpotmeterConfig() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_SPOTMETER_CONFIG, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int[] regionOfInterest = new int[4];
		for (int i = 0; i < 4; i++) {
			regionOfInterest[i] = IPConnection.unsignedByte(bb.get());
		}

		return regionOfInterest;
	}

	/**
	 * Sets the high contrast region of interest, dampening factor, clip limit and empty counts.
	 * This config is only used in high contrast mode (see {@link BrickletThermalImaging#setImageTransferConfig(int)}).
	 * 
	 * The high contrast region of interest consists of four values:
	 * 
	 * * Index 0: Column start (has to be smaller or equal then Column end).
	 * * Index 1: Row start (has to be smaller then Row end).
	 * * Index 2: Column end (has to be smaller then 80).
	 * * Index 3: Row end (has to be smaller then 60).
	 * 
	 * The algorithm to generate the high contrast image is applied to this region.
	 * 
	 * Dampening Factor: This parameter is the amount of temporal dampening applied to the HEQ
	 * (history equalization) transformation function. An IIR filter of the form::
	 * 
	 *  (N / 256) * previous + ((256 - N) / 256) * current
	 * 
	 * is applied, and the HEQ dampening factor
	 * represents the value N in the equation, i.e., a value that applies to the amount of
	 * influence the previous HEQ transformation function has on the current function. The
	 * lower the value of N the higher the influence of the current video frame whereas
	 * the higher the value of N the more influence the previous damped transfer function has.
	 * 
	 * Clip Limit Index 0 (AGC HEQ Clip Limit High): This parameter defines the maximum number of pixels allowed
	 * to accumulate in any given histogram bin. Any additional pixels in a given bin are clipped.
	 * The effect of this parameter is to limit the influence of highly-populated bins on the
	 * resulting HEQ transformation function.
	 * 
	 * Clip Limit Index 1 (AGC HEQ Clip Limit Low): This parameter defines an artificial population that is added to
	 * every non-empty histogram bin. In other words, if the Clip Limit Low is set to L, a bin
	 * with an actual population of X will have an effective population of L + X. Any empty bin
	 * that is nearby a populated bin will be given an artificial population of L. The effect of
	 * higher values is to provide a more linear transfer function; lower values provide a more
	 * non-linear (equalized) transfer function.
	 * 
	 * Empty Counts: This parameter specifies the maximum number of pixels in a bin that will be
	 * interpreted as an empty bin. Histogram bins with this number of pixels or less will be
	 * processed as an empty bin.
	 */
	public void setHighContrastConfig(int[] regionOfInterest, int dampeningFactor, int[] clipLimit, int emptyCounts) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)20, FUNCTION_SET_HIGH_CONTRAST_CONFIG, this);

		for (int i = 0; i < 4; i++) {
			bb.put((byte)regionOfInterest[i]);
		}
		bb.putShort((short)dampeningFactor);
		for (int i = 0; i < 2; i++) {
			bb.putShort((short)clipLimit[i]);
		}
		bb.putShort((short)emptyCounts);

		sendRequest(bb.array());
	}

	/**
	 * Returns the high contrast config as set by {@link BrickletThermalImaging#setHighContrastConfig(int[], int, int[], int)}.
	 */
	public HighContrastConfig getHighContrastConfig() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_HIGH_CONTRAST_CONFIG, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		HighContrastConfig obj = new HighContrastConfig();
		for (int i = 0; i < 4; i++) {
			obj.regionOfInterest[i] = IPConnection.unsignedByte(bb.get());
		}
		obj.dampeningFactor = IPConnection.unsignedShort(bb.getShort());
		for (int i = 0; i < 2; i++) {
			obj.clipLimit[i] = IPConnection.unsignedShort(bb.getShort());
		}
		obj.emptyCounts = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * The necessary bandwidth of this Bricklet is too high to use getter/listener or
	 * high contrast/temperature image at the same time. You have to configure the one
	 * you want to use, the Bricklet will optimize the internal configuration accordingly.
	 * 
	 * Corresponding functions:
	 * 
	 * * Manual High Contrast Image: {@link BrickletThermalImaging#getHighContrastImage()}.
	 * * Manual Temperature Image: {@link BrickletThermalImaging#getTemperatureImage()}.
	 * * Listener High Contrast Image: {@link BrickletThermalImaging.HighContrastImageListener} listener.
	 * * Listener Temperature Image: {@link BrickletThermalImaging.TemperatureImageListener} listener.
	 */
	public void setImageTransferConfig(int config) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_IMAGE_TRANSFER_CONFIG, this);

		bb.put((byte)config);

		sendRequest(bb.array());
	}

	/**
	 * Returns the image transfer config, as set by {@link BrickletThermalImaging#setImageTransferConfig(int)}.
	 */
	public int getImageTransferConfig() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IMAGE_TRANSFER_CONFIG, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int config = IPConnection.unsignedByte(bb.get());

		return config;
	}

	/**
	 * Returns the error count for the communication between Brick and Bricklet.
	 * 
	 * The errors are divided into
	 * 
	 * * ACK checksum errors,
	 * * message checksum errors,
	 * * framing errors and
	 * * overflow errors.
	 * 
	 * The errors counts are for errors that occur on the Bricklet side. All
	 * Bricks have a similar function that returns the errors on the Brick side.
	 */
	public SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_SPITFP_ERROR_COUNT, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		SPITFPErrorCount obj = new SPITFPErrorCount();
		obj.errorCountAckChecksum = IPConnection.unsignedInt(bb.getInt());
		obj.errorCountMessageChecksum = IPConnection.unsignedInt(bb.getInt());
		obj.errorCountFrame = IPConnection.unsignedInt(bb.getInt());
		obj.errorCountOverflow = IPConnection.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Sets the bootloader mode and returns the status after the requested
	 * mode change was instigated.
	 * 
	 * You can change from bootloader mode to firmware mode and vice versa. A change
	 * from bootloader mode to firmware mode will only take place if the entry function,
	 * device identifier and CRC are present and correct.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int setBootloaderMode(int mode) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_BOOTLOADER_MODE, this);

		bb.put((byte)mode);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnection.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Returns the current bootloader mode, see {@link BrickletThermalImaging#setBootloaderMode(int)}.
	 */
	public int getBootloaderMode() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_BOOTLOADER_MODE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int mode = IPConnection.unsignedByte(bb.get());

		return mode;
	}

	/**
	 * Sets the firmware pointer for {@link BrickletThermalImaging#writeFirmware(int[])}. The pointer has
	 * to be increased by chunks of size 64. The data is written to flash
	 * every 4 chunks (which equals to one page of size 256).
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_WRITE_FIRMWARE_POINTER, this);

		bb.putInt((int)pointer);

		sendRequest(bb.array());
	}

	/**
	 * Writes 64 Bytes of firmware at the position as written by
	 * {@link BrickletThermalImaging#setWriteFirmwarePointer(long)} before. The firmware is written
	 * to flash every 4 chunks.
	 * 
	 * You can only write firmware in bootloader mode.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int writeFirmware(int[] data) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)72, FUNCTION_WRITE_FIRMWARE, this);

		for (int i = 0; i < 64; i++) {
			bb.put((byte)data[i]);
		}

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnection.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Sets the status LED configuration. By default the LED shows
	 * communication traffic between Brick and Bricklet, it flickers once
	 * for every 10 received data packets.
	 * 
	 * You can also turn the LED permanently on/off or show a heartbeat.
	 * 
	 * If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
	 */
	public void setStatusLEDConfig(int config) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_STATUS_LED_CONFIG, this);

		bb.put((byte)config);

		sendRequest(bb.array());
	}

	/**
	 * Returns the configuration as set by {@link BrickletThermalImaging#setStatusLEDConfig(int)}
	 */
	public int getStatusLEDConfig() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_STATUS_LED_CONFIG, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int config = IPConnection.unsignedByte(bb.get());

		return config;
	}

	/**
	 * Returns the temperature as measured inside the microcontroller. The
	 * value returned is not the ambient temperature!
	 * 
	 * The temperature is only proportional to the real temperature and it has bad
	 * accuracy. Practically it is only useful as an indicator for
	 * temperature changes.
	 */
	public int getChipTemperature() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CHIP_TEMPERATURE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int temperature = (bb.getShort());

		return temperature;
	}

	/**
	 * Calling this function will reset the Bricklet. All configurations
	 * will be lost.
	 * 
	 * After a reset you have to create new device objects,
	 * calling functions on the existing ones will result in
	 * undefined behavior!
	 */
	public void reset() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_RESET, this);


		sendRequest(bb.array());
	}

	/**
	 * Writes a new UID into flash. If you want to set a new UID
	 * you have to decode the Base58 encoded UID string into an
	 * integer first.
	 * 
	 * We recommend that you use Brick Viewer to change the UID.
	 */
	public void writeUID(long uid) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_WRITE_UID, this);

		bb.putInt((int)uid);

		sendRequest(bb.array());
	}

	/**
	 * Returns the current UID as an integer. Encode as
	 * Base58 to get the usual string version.
	 */
	public long readUID() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_READ_UID, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long uid = IPConnection.unsignedInt(bb.getInt());

		return uid;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
	 * The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
	 * connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always as
	 * position 'z'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnection.string(bb, 8);
		obj.connectedUid = IPConnection.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Returns the current high contrast image. See `here &lt;https://www.tinkerforge.com/en/doc/Hardware/Bricklets/Thermal_Imaging.html#high-contrast-image-vs-temperature-image&gt;`__
	 * for the difference between
	 * High Contrast and Temperature Image. If you don't know what to use
	 * the High Contrast Image is probably right for you.
	 * 
	 * The data is organized as a 8-bit value 80x60 pixel matrix linearized in
	 * a one-dimensional array. The data is arranged line by line from top left to
	 * bottom right.
	 * 
	 * Each 8-bit value represents one gray-scale image pixel that can directly be
	 * shown to a user on a display.
	 * 
	 * Before you can use this function you have to enable it with
	 * {@link BrickletThermalImaging#setImageTransferConfig(int)}.
	 */
	public int[] getHighContrastImage() throws TinkerforgeException {
		HighContrastImageLowLevel ret;
		int[] image = null; // stop the compiler from wrongly complaining that this variable is used unassigned
		int imageLength = 4800;
		int imageChunkOffset;
		int imageChunkLength;
		boolean imageOutOfSync;
		int imageCurrentLength;

		synchronized (streamMutex) {
			ret = getHighContrastImageLowLevel();

			if (ret.imageChunkOffset == (1 << 16) - 1) { // maximum chunk offset -> stream has no data
				imageLength = 0;
				imageChunkOffset = 0;
				imageOutOfSync = false;
			} else {
				imageChunkOffset = ret.imageChunkOffset;
				imageOutOfSync = imageChunkOffset != 0;
			}

			if (!imageOutOfSync) {
				image = new int[imageLength];
				imageChunkLength = Math.min(imageLength - imageChunkOffset, 62);

				System.arraycopy(ret.imageChunkData, 0, image, 0, imageChunkLength);

				imageCurrentLength = imageChunkLength;

				while (imageCurrentLength < imageLength) {
					ret = getHighContrastImageLowLevel();
					imageOutOfSync = ret.imageChunkOffset != imageCurrentLength;

					if (imageOutOfSync) {
						break;
					}

					imageChunkLength = Math.min(imageLength - ret.imageChunkOffset, 62);

					System.arraycopy(ret.imageChunkData, 0, image, imageCurrentLength, imageChunkLength);

					imageCurrentLength += imageChunkLength;
				}
			}

			if (imageOutOfSync) { // discard remaining stream to bring it back in-sync
				while (ret.imageChunkOffset + 62 < imageLength) {
					ret = getHighContrastImageLowLevel();
				}

				throw new StreamOutOfSyncException("Image stream is out-of-sync");
			}
		}

		return image;
	}

	/**
	 * Returns the current temperature image. See `here &lt;https://www.tinkerforge.com/en/doc/Hardware/Bricklets/Thermal_Imaging.html#high-contrast-image-vs-temperature-image&gt;`__
	 * for the difference between High Contrast and Temperature Image.
	 * If you don't know what to use the High Contrast Image is probably right for you.
	 * 
	 * The data is organized as a 16-bit value 80x60 pixel matrix linearized in
	 * a one-dimensional array. The data is arranged line by line from top left to
	 * bottom right.
	 * 
	 * Each 16-bit value represents one temperature measurement in either
	 * Kelvin/10 or Kelvin/100 (depending on the resolution set with {@link BrickletThermalImaging#setResolution(int)}).
	 * 
	 * Before you can use this function you have to enable it with
	 * {@link BrickletThermalImaging#setImageTransferConfig(int)}.
	 */
	public int[] getTemperatureImage() throws TinkerforgeException {
		TemperatureImageLowLevel ret;
		int[] image = null; // stop the compiler from wrongly complaining that this variable is used unassigned
		int imageLength = 4800;
		int imageChunkOffset;
		int imageChunkLength;
		boolean imageOutOfSync;
		int imageCurrentLength;

		synchronized (streamMutex) {
			ret = getTemperatureImageLowLevel();

			if (ret.imageChunkOffset == (1 << 16) - 1) { // maximum chunk offset -> stream has no data
				imageLength = 0;
				imageChunkOffset = 0;
				imageOutOfSync = false;
			} else {
				imageChunkOffset = ret.imageChunkOffset;
				imageOutOfSync = imageChunkOffset != 0;
			}

			if (!imageOutOfSync) {
				image = new int[imageLength];
				imageChunkLength = Math.min(imageLength - imageChunkOffset, 31);

				System.arraycopy(ret.imageChunkData, 0, image, 0, imageChunkLength);

				imageCurrentLength = imageChunkLength;

				while (imageCurrentLength < imageLength) {
					ret = getTemperatureImageLowLevel();
					imageOutOfSync = ret.imageChunkOffset != imageCurrentLength;

					if (imageOutOfSync) {
						break;
					}

					imageChunkLength = Math.min(imageLength - ret.imageChunkOffset, 31);

					System.arraycopy(ret.imageChunkData, 0, image, imageCurrentLength, imageChunkLength);

					imageCurrentLength += imageChunkLength;
				}
			}

			if (imageOutOfSync) { // discard remaining stream to bring it back in-sync
				while (ret.imageChunkOffset + 31 < imageLength) {
					ret = getTemperatureImageLowLevel();
				}

				throw new StreamOutOfSyncException("Image stream is out-of-sync");
			}
		}

		return image;
	}

	/**
	 * Adds a HighContrastImageLowLevel listener.
	 */
	public void addHighContrastImageLowLevelListener(HighContrastImageLowLevelListener listener) {
		listenerHighContrastImageLowLevel.add(listener);
	}

	/**
	 * Removes a HighContrastImageLowLevel listener.
	 */
	public void removeHighContrastImageLowLevelListener(HighContrastImageLowLevelListener listener) {
		listenerHighContrastImageLowLevel.remove(listener);
	}

	/**
	 * Adds a TemperatureImageLowLevel listener.
	 */
	public void addTemperatureImageLowLevelListener(TemperatureImageLowLevelListener listener) {
		listenerTemperatureImageLowLevel.add(listener);
	}

	/**
	 * Removes a TemperatureImageLowLevel listener.
	 */
	public void removeTemperatureImageLowLevelListener(TemperatureImageLowLevelListener listener) {
		listenerTemperatureImageLowLevel.remove(listener);
	}

	/**
	 * Adds a HighContrastImage listener.
	 */
	public void addHighContrastImageListener(HighContrastImageListener listener) {
		listenerHighContrastImage.add(listener);
	}

	/**
	 * Removes a HighContrastImage listener.
	 */
	public void removeHighContrastImageListener(HighContrastImageListener listener) {
		listenerHighContrastImage.remove(listener);
	}

	/**
	 * Adds a TemperatureImage listener.
	 */
	public void addTemperatureImageListener(TemperatureImageListener listener) {
		listenerTemperatureImage.add(listener);
	}

	/**
	 * Removes a TemperatureImage listener.
	 */
	public void removeTemperatureImageListener(TemperatureImageListener listener) {
		listenerTemperatureImage.remove(listener);
	}

    private final Logger logger = LoggerFactory.getLogger(BrickletThermalImaging.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletThermalImaging.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletThermalImagingConfig cfg = (BrickletThermalImagingConfig) config.as(BrickletThermalImagingConfig.class);
        
        this.setImageTransferConfig(cfg.imageType);
		    this.setResolution(cfg.resolution);
		    this.setSpotmeterConfig(new int[]{cfg.spotmeterColumnStart, cfg.spotmeterRowStart, cfg.spotmeterColumnEnd, cfg.spotmeterRowEnd});
		this.setStatusLEDConfig(cfg.statusLEDConfig);
		if (cfg.imageType == 0) {
		BrickletThermalImagingHighContrastImageConfig channelCfg = getChannelConfigFn.apply("BrickletThermalImagingHighContrastImage").as(BrickletThermalImagingHighContrastImageConfig.class);
		this.setHighContrastConfig(new int[]{channelCfg.highContrastColumnStart, channelCfg.highContrastRowStart, channelCfg.highContrastColumnEnd, channelCfg.highContrastRowEnd}, channelCfg.dampeningFactor, new int[]{channelCfg.clipLimitHigh, channelCfg.clipLimitLow}, channelCfg.emptyCounts);
		}
		if (cfg.imageType == 1) {
		BrickletThermalImagingTemperatureImageConfig channelCfg = getChannelConfigFn.apply("BrickletThermalImagingTemperatureImage").as(BrickletThermalImagingTemperatureImageConfig.class);
		
		}
		{
		BrickletThermalImagingTemperatureConfig channelCfg = getChannelConfigFn.apply("BrickletThermalImagingSpotmeterMeanTemperature").as(BrickletThermalImagingTemperatureConfig.class);
		
		}
		{
		BrickletThermalImagingTemperatureConfig channelCfg = getChannelConfigFn.apply("BrickletThermalImagingSpotmeterMaximumTemperature").as(BrickletThermalImagingTemperatureConfig.class);
		
		}
		{
		BrickletThermalImagingTemperatureConfig channelCfg = getChannelConfigFn.apply("BrickletThermalImagingSpotmeterMinimumTemperature").as(BrickletThermalImagingTemperatureConfig.class);
		
		}
		{
		BrickletThermalImagingSpotmeterROIPixelCountConfig channelCfg = getChannelConfigFn.apply("BrickletThermalImagingSpotmeterROIPixelCount").as(BrickletThermalImagingSpotmeterROIPixelCountConfig.class);
		
		}
		{
		BrickletThermalImagingTemperatureConfig channelCfg = getChannelConfigFn.apply("BrickletThermalImagingFocalPlainArrayTemperature").as(BrickletThermalImagingTemperatureConfig.class);
		
		}
		{
		BrickletThermalImagingTemperatureConfig channelCfg = getChannelConfigFn.apply("BrickletThermalImagingFocalPlainArrayTemperatureFFC").as(BrickletThermalImagingTemperatureConfig.class);
		
		}
		{
		BrickletThermalImagingTemperatureConfig channelCfg = getChannelConfigFn.apply("BrickletThermalImagingHousingTemperature").as(BrickletThermalImagingTemperatureConfig.class);
		
		}
		{
		BrickletThermalImagingTemperatureConfig channelCfg = getChannelConfigFn.apply("BrickletThermalImagingHousingTemperatureFFC").as(BrickletThermalImagingTemperatureConfig.class);
		
		}
		{
		BrickletThermalImagingFFCStatusConfig channelCfg = getChannelConfigFn.apply("BrickletThermalImagingFFCStatus").as(BrickletThermalImagingFFCStatusConfig.class);
		
		}
		{
		BrickletThermalImagingShutterLockoutConfig channelCfg = getChannelConfigFn.apply("BrickletThermalImagingShutterLockout").as(BrickletThermalImagingShutterLockoutConfig.class);
		
		}
		{
		BrickletThermalImagingOvertemperatureShutdownImminentConfig channelCfg = getChannelConfigFn.apply("BrickletThermalImagingOvertemperatureShutdownImminent").as(BrickletThermalImagingOvertemperatureShutdownImminentConfig.class);
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        BrickletThermalImagingConfig cfg = (BrickletThermalImagingConfig) config.as(BrickletThermalImagingConfig.class);
        
        
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletThermalImagingConfig cfg = (BrickletThermalImagingConfig) config.as(BrickletThermalImagingConfig.class);
        List<String> result = new ArrayList<String>();
        if (cfg.imageType == 0) {
                result.add("BrickletThermalImagingHighContrastImage");
            }
		if (cfg.imageType == 1) {
                result.add("BrickletThermalImagingTemperatureImage");
            }
		result.add("BrickletThermalImagingSpotmeterMeanTemperature");
		result.add("BrickletThermalImagingSpotmeterMaximumTemperature");
		result.add("BrickletThermalImagingSpotmeterMinimumTemperature");
		result.add("BrickletThermalImagingSpotmeterROIPixelCount");
		result.add("BrickletThermalImagingFocalPlainArrayTemperature");
		result.add("BrickletThermalImagingFocalPlainArrayTemperatureFFC");
		result.add("BrickletThermalImagingHousingTemperature");
		result.add("BrickletThermalImagingHousingTemperatureFFC");
		result.add("BrickletThermalImagingFFCStatus");
		result.add("BrickletThermalImagingShutterLockout");
		result.add("BrickletThermalImagingOvertemperatureShutdownImminent");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletThermalImagingHighContrastImage":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletThermalImagingHighContrastImage"), "High Contrast Image", "Image").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletThermalImagingHighContrastImage")).withDescription("The current high contrast image. See <a href=\"https://www.tinkerforge.com/en/doc/Hardware/Bricklets/Thermal_Imaging.html#high-contrast-image-vs-temperature-image\">here</a> for the difference between High Contrast and Temperature Image. If you don't know what to use the High Contrast Image is probably right for you.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(true).build().toStateDescription()).build();
            case "BrickletThermalImagingTemperatureImage":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletThermalImagingTemperatureImage"), "Temperature Image", "Image").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletThermalImagingTemperatureImage")).withDescription("The current temperature image. See <a href=\"https://www.tinkerforge.com/en/doc/Hardware/Bricklets/Thermal_Imaging.html#high-contrast-image-vs-temperature-image\">here</a> for the difference between High Contrast and Temperature Image. If you don't know what to use the High Contrast Image is probably right for you.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(true).build().toStateDescription()).build();
            case "BrickletThermalImagingTemperature":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletThermalImagingTemperature"), "NOT USED", "Number:Temperature").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletThermalImagingTemperature")).withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%.3f %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletThermalImagingSpotmeterROIPixelCount":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletThermalImagingSpotmeterROIPixelCount"), "Spotmeter ROI Pixel Count", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletThermalImagingSpotmeterROIPixelCount")).withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%.3f %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletThermalImagingFFCStatus":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletThermalImagingFFCStatus"), "FFC Status", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletThermalImagingFFCStatus")).withDescription("Flat Field Correction Status")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(3)).withReadOnly(true).withOptions(Arrays.asList(new StateOption("0", "Never Commanded"), new StateOption("1", "Imminent"), new StateOption("2", "In Progress"), new StateOption("3", "Complete"))).build().toStateDescription()).build();
            case "BrickletThermalImagingShutterLockout":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletThermalImagingShutterLockout"), "Shutter Lockout", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletThermalImagingShutterLockout")).withDescription("If enabled, shutter is locked out because temperature is outside -10°C to +65°C")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(true).build().toStateDescription()).build();
            case "BrickletThermalImagingOvertemperatureShutdownImminent":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletThermalImagingOvertemperatureShutdownImminent"), "Overtemperature Shutdown Imminent", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletThermalImagingOvertemperatureShutdownImminent")).withDescription("Gets enabled 10 seconds before shutdown.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Thermal Imaging Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("80x60 pixel thermal imaging camera").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletThermalImagingHighContrastImage", new ChannelTypeUID("tinkerforge", "BrickletThermalImagingHighContrastImage")).withLabel("High Contrast Image").build(), new ChannelDefinitionBuilder("BrickletThermalImagingTemperatureImage", new ChannelTypeUID("tinkerforge", "BrickletThermalImagingTemperatureImage")).withLabel("Temperature Image").build(), new ChannelDefinitionBuilder("BrickletThermalImagingSpotmeterMeanTemperature", new ChannelTypeUID("tinkerforge", "BrickletThermalImagingTemperature")).withLabel("Spotmeter Mean Temperature").withDescription("Mean temperature in the spotmeter region of interest.").build(), new ChannelDefinitionBuilder("BrickletThermalImagingSpotmeterMaximumTemperature", new ChannelTypeUID("tinkerforge", "BrickletThermalImagingTemperature")).withLabel("Spotmeter Maximum Temperature").withDescription("Maximum temperature in the spotmeter region of interest.").build(), new ChannelDefinitionBuilder("BrickletThermalImagingSpotmeterMinimumTemperature", new ChannelTypeUID("tinkerforge", "BrickletThermalImagingTemperature")).withLabel("Spotmeter Minimum Temperature").withDescription("Minimum temperature in the spotmeter region of interest.").build(), new ChannelDefinitionBuilder("BrickletThermalImagingSpotmeterROIPixelCount", new ChannelTypeUID("tinkerforge", "BrickletThermalImagingSpotmeterROIPixelCount")).withLabel("Spotmeter ROI Pixel Count").withDescription("Number of pixels in the spotmeter region of interest.").build(), new ChannelDefinitionBuilder("BrickletThermalImagingFocalPlainArrayTemperature", new ChannelTypeUID("tinkerforge", "BrickletThermalImagingTemperature")).withLabel("Focal Plain Array Temperature").withDescription("Current Focal Plain Array temperature").build(), new ChannelDefinitionBuilder("BrickletThermalImagingFocalPlainArrayTemperatureFFC", new ChannelTypeUID("tinkerforge", "BrickletThermalImagingTemperature")).withLabel("Focal Plain Array Temperature (last FFC)").withDescription("Focal Plain Array temperature at last FFC (Flat Field Correction).").build(), new ChannelDefinitionBuilder("BrickletThermalImagingHousingTemperature", new ChannelTypeUID("tinkerforge", "BrickletThermalImagingTemperature")).withLabel("Housing Temperature").withDescription("Current Housing temperature.").build(), new ChannelDefinitionBuilder("BrickletThermalImagingHousingTemperatureFFC", new ChannelTypeUID("tinkerforge", "BrickletThermalImagingTemperature")).withLabel("Housing Temperature (last FFC)").withDescription("Housing temperature at last FFC (Flat Field Correction).").build(), new ChannelDefinitionBuilder("BrickletThermalImagingFFCStatus", new ChannelTypeUID("tinkerforge", "BrickletThermalImagingFFCStatus")).withLabel("Flat Field Correction Status").build(), new ChannelDefinitionBuilder("BrickletThermalImagingShutterLockout", new ChannelTypeUID("tinkerforge", "BrickletThermalImagingShutterLockout")).withLabel("Shutter Lockout").build(), new ChannelDefinitionBuilder("BrickletThermalImagingOvertemperatureShutdownImminent", new ChannelTypeUID("tinkerforge", "BrickletThermalImagingOvertemperatureShutdownImminent")).withLabel("Overtemperature Shutdown Imminent").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletthermalimaging":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("imageType", Type.INTEGER).withDefault("0").withDescription("The necessary bandwidth of this Bricklet is too high to use the high contrast and temperature image at the same time. You have to configure the one you want to use, the Bricklet will optimize the internal configuration accordingly.").withLabel("Image Type").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("0", "High Contrast Image"), new ParameterOption("1", "Linear Temperature Image"))).build(), ConfigDescriptionParameterBuilder.create("resolution", Type.INTEGER).withDefault("1").withDescription("The Thermal Imaging Bricklet can either measure<ul><li>from 0 to 6553 Kelvin (-273.15°C to +6279.85°C) with 0.1°C resolution or</li><li>from 0 to 655 Kelvin (-273.15°C to +381.85°C) with 0.01°C resolution.</li></ul><br/>The accuracy is specified for -10°C to 450°C in the first range and -10°C and 140°C in the second range.").withLabel("Resolution").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("0", "0 To 6553 Kelvin"), new ParameterOption("1", "0 To 655 Kelvin"))).build(), ConfigDescriptionParameterBuilder.create("colorPalette", Type.INTEGER).withDefault("0").withDescription("The thermal image color palette.").withLabel("Color Palette").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("0", "Standard"), new ParameterOption("1", "Greyscale"), new ParameterOption("2", "Hot Cold"))).build(), ConfigDescriptionParameterBuilder.create("spotmeterColumnStart", Type.INTEGER).withDefault("39").withDescription("First column of the spotmeter region of interest.").withLabel("Spotmeter Column Start").withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(79)).build(), ConfigDescriptionParameterBuilder.create("spotmeterRowStart", Type.INTEGER).withDefault("29").withDescription("First row of the spotmeter region of interest.").withLabel("Spotmeter Row Start").withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(59)).build(), ConfigDescriptionParameterBuilder.create("spotmeterColumnEnd", Type.INTEGER).withDefault("40").withDescription("Last column of the spotmeter region of interest.").withLabel("Spotmeter Column End").withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(79)).build(), ConfigDescriptionParameterBuilder.create("spotmeterRowEnd", Type.INTEGER).withDefault("30").withDescription("Last row of the spotmeter region of interest.").withLabel("Spotmeter Row End").withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(59)).build(), ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.INTEGER).withDefault("3").withDescription("The status LED configuration. By default the LED shows communication traffic between Brick and Bricklet, it flickers once for every 10 received data packets.<br/><br/>You can also turn the LED permanently on/off or show a heartbeat.<br/><br/>If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.").withLabel("Status LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Status"))).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletThermalImagingHighContrastImage":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("highContrastColumnStart", Type.INTEGER).withDefault("0").withDescription("First column of the high contrast region of interest.").withLabel("High Contrast Column Start").withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(79)).build(), ConfigDescriptionParameterBuilder.create("highContrastRowStart", Type.INTEGER).withDefault("0").withDescription("First row of the high contrast region of interest.").withLabel("High Contrast Row Start").withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(59)).build(), ConfigDescriptionParameterBuilder.create("highContrastColumnEnd", Type.INTEGER).withDefault("79").withDescription("Last column of the high contrast region of interest.").withLabel("High Contrast Column End").withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(79)).build(), ConfigDescriptionParameterBuilder.create("highContrastRowEnd", Type.INTEGER).withDefault("59").withDescription("Last row of the high contrast region of interest.").withLabel("High Contrast Row End").withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(59)).build(), ConfigDescriptionParameterBuilder.create("dampeningFactor", Type.INTEGER).withDefault("64").withDescription("This parameter is the amount of temporal dampening applied to the HEQ (history equalization) transformation function. An IIR filter of the form:<pre>(N / 256) * previous + ((256 - N) / 256) * current</pre>is applied, and the HEQ dampening factor represents the value N in the equation, i.e., a value that applies to the amount of influence the previous HEQ transformation function has on the current function. The lower the value of N the higher the influence of the current video frame whereas the higher the value of N the more influence the previous damped transfer function has.").withLabel("Dampening Factor").withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(256)).build(), ConfigDescriptionParameterBuilder.create("clipLimitLow", Type.INTEGER).withDefault("512").withDescription("This parameter defines an artificial population that is added to every non-empty histogram bin. In other words, if the Clip Limit Low is set to L, a bin with an actual population of X will have an effective population of L + X. Any empty bin that is nearby a populated bin will be given an artificial population of L. The effect of higher values is to provide a more linear transfer function; lower values provide a more non-linear (equalized) transfer function.").withLabel("AGC HEQ Clip Limit Low").withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(1024)).build(), ConfigDescriptionParameterBuilder.create("clipLimitHigh", Type.INTEGER).withDefault("4800").withDescription("This parameter defines the maximum number of pixels allowed to accumulate in any given histogram bin. Any additional pixels in a given bin are clipped. The effect of this parameter is to limit the influence of highly-populated bins on the resulting HEQ transformation function.").withLabel("AGC HEQ Clip Limit High").withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(4800)).build(), ConfigDescriptionParameterBuilder.create("emptyCounts", Type.INTEGER).withDefault("2").withDescription(" This parameter specifies the maximum number of pixels in a bin that will be interpreted as an empty bin. Histogram bins with this number of pixels or less will be processed as an empty bin.").withLabel("Empty Counts").withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(16383)).build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletThermalImagingTemperatureImage":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletThermalImagingTemperature":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletThermalImagingSpotmeterROIPixelCount":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletThermalImagingFFCStatus":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletThermalImagingShutterLockout":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletThermalImagingOvertemperatureShutdownImminent":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletThermalImagingConfig cfg = (BrickletThermalImagingConfig) config.as(BrickletThermalImagingConfig.class);
        switch(channel) {
            case "BrickletThermalImagingHighContrastImage": {
                   BrickletThermalImagingHighContrastImageConfig channelCfg = channelConfig.as(BrickletThermalImagingHighContrastImageConfig.class);
                   {
            int[] value = this.getHighContrastImage();
            if(true)
                updateStateFn.accept(channel, transformBrickletThermalImagingHighContrastImageGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletThermalImagingTemperatureImage": {
                   BrickletThermalImagingTemperatureImageConfig channelCfg = channelConfig.as(BrickletThermalImagingTemperatureImageConfig.class);
                   {
            int[] value = this.getTemperatureImage();
            if(true)
                updateStateFn.accept(channel, transformBrickletThermalImagingTemperatureImageGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletThermalImagingSpotmeterMeanTemperature": {
                   BrickletThermalImagingTemperatureConfig channelCfg = channelConfig.as(BrickletThermalImagingTemperatureConfig.class);
                   {
            Statistics value = this.getStatistics();
            if(true)
                updateStateFn.accept(channel, transformBrickletThermalImagingSpotmeterMeanTemperatureGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletThermalImagingSpotmeterMaximumTemperature": {
                   BrickletThermalImagingTemperatureConfig channelCfg = channelConfig.as(BrickletThermalImagingTemperatureConfig.class);
                   {
            Statistics value = this.getStatistics();
            if(true)
                updateStateFn.accept(channel, transformBrickletThermalImagingSpotmeterMaximumTemperatureGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletThermalImagingSpotmeterMinimumTemperature": {
                   BrickletThermalImagingTemperatureConfig channelCfg = channelConfig.as(BrickletThermalImagingTemperatureConfig.class);
                   {
            Statistics value = this.getStatistics();
            if(true)
                updateStateFn.accept(channel, transformBrickletThermalImagingSpotmeterMinimumTemperatureGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletThermalImagingSpotmeterROIPixelCount": {
                   BrickletThermalImagingSpotmeterROIPixelCountConfig channelCfg = channelConfig.as(BrickletThermalImagingSpotmeterROIPixelCountConfig.class);
                   {
            Statistics value = this.getStatistics();
            if(true)
                updateStateFn.accept(channel, transformBrickletThermalImagingSpotmeterROIPixelCountGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletThermalImagingFocalPlainArrayTemperature": {
                   BrickletThermalImagingTemperatureConfig channelCfg = channelConfig.as(BrickletThermalImagingTemperatureConfig.class);
                   {
            Statistics value = this.getStatistics();
            if(true)
                updateStateFn.accept(channel, transformBrickletThermalImagingFocalPlainArrayTemperatureGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletThermalImagingFocalPlainArrayTemperatureFFC": {
                   BrickletThermalImagingTemperatureConfig channelCfg = channelConfig.as(BrickletThermalImagingTemperatureConfig.class);
                   {
            Statistics value = this.getStatistics();
            if(true)
                updateStateFn.accept(channel, transformBrickletThermalImagingFocalPlainArrayTemperatureFFCGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletThermalImagingHousingTemperature": {
                   BrickletThermalImagingTemperatureConfig channelCfg = channelConfig.as(BrickletThermalImagingTemperatureConfig.class);
                   {
            Statistics value = this.getStatistics();
            if(true)
                updateStateFn.accept(channel, transformBrickletThermalImagingHousingTemperatureGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletThermalImagingHousingTemperatureFFC": {
                   BrickletThermalImagingTemperatureConfig channelCfg = channelConfig.as(BrickletThermalImagingTemperatureConfig.class);
                   {
            Statistics value = this.getStatistics();
            if(true)
                updateStateFn.accept(channel, transformBrickletThermalImagingHousingTemperatureFFCGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletThermalImagingFFCStatus": {
                   BrickletThermalImagingFFCStatusConfig channelCfg = channelConfig.as(BrickletThermalImagingFFCStatusConfig.class);
                   {
            Statistics value = this.getStatistics();
            if(true)
                updateStateFn.accept(channel, transformBrickletThermalImagingFFCStatusGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletThermalImagingShutterLockout": {
                   BrickletThermalImagingShutterLockoutConfig channelCfg = channelConfig.as(BrickletThermalImagingShutterLockoutConfig.class);
                   {
            Statistics value = this.getStatistics();
            if(true)
                updateStateFn.accept(channel, transformBrickletThermalImagingShutterLockoutGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletThermalImagingOvertemperatureShutdownImminent": {
                   BrickletThermalImagingOvertemperatureShutdownImminentConfig channelCfg = channelConfig.as(BrickletThermalImagingOvertemperatureShutdownImminentConfig.class);
                   {
            Statistics value = this.getStatistics();
            if(true)
                updateStateFn.accept(channel, transformBrickletThermalImagingOvertemperatureShutdownImminentGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletThermalImagingConfig cfg = (BrickletThermalImagingConfig) config.as(BrickletThermalImagingConfig.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletThermalImagingHighContrastImageGetter0(int[] value, BrickletThermalImagingConfig cfg) {
        return new RawType(Helper.convertThermalHighContrastImage(value, cfg.colorPalette, logger), "image/png");
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletThermalImagingTemperatureImageGetter0(int[] value, BrickletThermalImagingConfig cfg) {
        return new RawType(Helper.convertThermalTemperatureImage(value, cfg.colorPalette, logger), "image/png");
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletThermalImagingSpotmeterMeanTemperatureGetter0(Statistics value, BrickletThermalImagingConfig cfg) {
        return new QuantityType(value.spotmeterStatistics[0] / (cfg.resolution == 0 ? 10.0 : 100.0), SmartHomeUnits.KELVIN);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletThermalImagingSpotmeterMaximumTemperatureGetter0(Statistics value, BrickletThermalImagingConfig cfg) {
        return new QuantityType(value.spotmeterStatistics[1] / (cfg.resolution == 0 ? 10.0 : 100.0), SmartHomeUnits.KELVIN);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletThermalImagingSpotmeterMinimumTemperatureGetter0(Statistics value, BrickletThermalImagingConfig cfg) {
        return new QuantityType(value.spotmeterStatistics[2] / (cfg.resolution == 0 ? 10.0 : 100.0), SmartHomeUnits.KELVIN);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletThermalImagingSpotmeterROIPixelCountGetter0(Statistics value, BrickletThermalImagingConfig cfg) {
        return new QuantityType(value.spotmeterStatistics[3], SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletThermalImagingFocalPlainArrayTemperatureGetter0(Statistics value, BrickletThermalImagingConfig cfg) {
        return new QuantityType(value.temperatures[0] / (cfg.resolution == 0 ? 10.0 : 100.0), SmartHomeUnits.KELVIN);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletThermalImagingFocalPlainArrayTemperatureFFCGetter0(Statistics value, BrickletThermalImagingConfig cfg) {
        return new QuantityType(value.temperatures[1] / (cfg.resolution == 0 ? 10.0 : 100.0), SmartHomeUnits.KELVIN);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletThermalImagingHousingTemperatureGetter0(Statistics value, BrickletThermalImagingConfig cfg) {
        return new QuantityType(value.temperatures[2] / (cfg.resolution == 0 ? 10.0 : 100.0), SmartHomeUnits.KELVIN);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletThermalImagingHousingTemperatureFFCGetter0(Statistics value, BrickletThermalImagingConfig cfg) {
        return new QuantityType(value.temperatures[3] / (cfg.resolution == 0 ? 10.0 : 100.0), SmartHomeUnits.KELVIN);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletThermalImagingFFCStatusGetter0(Statistics value, BrickletThermalImagingConfig cfg) {
        return new QuantityType(value.ffcStatus, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletThermalImagingShutterLockoutGetter0(Statistics value, BrickletThermalImagingConfig cfg) {
        return value.temperatureWarning[0] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletThermalImagingOvertemperatureShutdownImminentGetter0(Statistics value, BrickletThermalImagingConfig cfg) {
        return value.temperatureWarning[1] ? OnOffType.ON : OnOffType.OFF;
    }
}
